/*
 * "$Id: font.h,v 1.1 1995/12/31 18:10:10 mike Exp mike $"
 *
 *   MS Windows font definitions for OpenGL.
 *
 * Revision History:
 *
 *   $Log: font.h,v $
 *   Revision 1.1  1995/12/31  18:10:10  mike
 *   Initial revision
 */

/*
 * Include necessary headers.
 */

#ifndef _FONT_H_
#  define _FONT_H_

#  include <stdio.h>
#  include <stdlib.h>
#  include <errno.h>
#  include <windows.h>

#  include <GL/gl.h>


/*
 * Make this header file work with C and C++ source code...
 */

#  ifdef __cplusplus
extern "C" {
#  endif /* __cplusplus */

extern GLuint	FontCreateBitmaps(HDC hdc, char *typeface, int height,
		                  int weight, DWORD italic);
extern GLuint	FontCreateOutlines(HDC hdc, char *typeface, int height,
		                   int weight, DWORD italic);
extern void	FontDelete(GLuint font);

extern void	FontPrintf(GLuint font, char *format, ...);
extern void	FontPuts(GLuint font, char *s);

#  ifdef __cplusplus
}
#  endif /* __cplusplus */
#endif /* !_FONT_H_ */

/*
 * End of "$Id: font.h,v 1.1 1995/12/31 18:10:10 mike Exp mike $".
 */
