// ocxAux.cpp
// This file contains wrappers for the Aux Library objects

#include "stdafx.h"
#include "WaiteGL.h"
#include "WaiteGLCtl.h"
#include "WaiteGLPpg.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


void CWaiteGLCtrl::auxSolidTeapot(double Size) 
	{
	::auxSolidTeapot(Size);
	}

void CWaiteGLCtrl::auxWireTeapot(double Size) 
	{
	::auxWireTeapot(Size);
	}

void CWaiteGLCtrl::auxSolidSphere(double radius) 
	{
	::auxSolidSphere(radius);
	}

void CWaiteGLCtrl::auxWireSphere(double radius) 
	{
	::auxWireSphere(radius);
	}

void CWaiteGLCtrl::auxWireCube(double size) 
	{
	::auxWireCube(size);
	}

void CWaiteGLCtrl::auxSolidCube(double size) 
	{
	::auxSolidCube(size);
	}
	
void CWaiteGLCtrl::auxWireBox(double width, double height, double depth) 
	{
	::auxWireBox(width, height, depth);
	}

void CWaiteGLCtrl::auxSolidBox(double width, double height, double depth) 
	{
	::auxSolidBox(width, height, depth);
	}

void CWaiteGLCtrl::auxWireTorus(double innerRadius, double outerRadius) 
	{
	::auxWireTorus(innerRadius, outerRadius);
	}

void CWaiteGLCtrl::auxSolidTorus(double innerRadius, double outerRadius) 
	{
	::auxSolidTorus(innerRadius, outerRadius);
	}

void CWaiteGLCtrl::auxWireCylinder(double radius, double height) 
	{
	::auxWireCylinder(radius, height);
	}

void CWaiteGLCtrl::auxSolidCylinder(double radius, double height) 
	{
	::auxSolidCylinder(radius, height);
	}

void CWaiteGLCtrl::auxWireIcosahedron(double radius) 
	{
	::auxWireIcosahedron(radius);
	}

void CWaiteGLCtrl::auxSolidIcosahedron(double radius) 
	{
	::auxSolidIcosahedron(radius);
	}
	
void CWaiteGLCtrl::auxWireOctahedron(double radius) 
	{
	::auxWireOctahedron(radius);
	}

void CWaiteGLCtrl::auxSolidOctahedron(double radius) 
	{
	::auxSolidOctahedron(radius);
	}

void CWaiteGLCtrl::auxWireDodecahedron(double radius) 
	{
	::auxWireDodecahedron(radius);
	}

void CWaiteGLCtrl::auxSolidDodecahedron(double radius) 
	{
	::auxSolidDodecahedron(radius);
	}

void CWaiteGLCtrl::auxWireCone(double radius, double height) 
	{
	::auxWireCone(radius, height);
	}

void CWaiteGLCtrl::auxSolidCone(double radius, double height) 
	{
	::auxSolidCone(radius, height);
	}
