// OcxFlags.cpp
// This file contains wrappers to extract the OpenGL flags and defines

#include "stdafx.h"
#include "WaiteGL.h"
#include "WaiteGLCtl.h"
#include "WaiteGLPpg.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


// Bitmask accessors
long CWaiteGLCtrl::glColorBufferBit() 
	{
	return (long)GL_COLOR_BUFFER_BIT;
	}


long CWaiteGLCtrl::glAccum() 
	{
	return GL_ACCUM;
	}



long CWaiteGLCtrl::glLoad() 
	{
	return GL_LOAD;
	}

long CWaiteGLCtrl::glReturn() 
	{
	return GL_RETURN;
	}

long CWaiteGLCtrl::glMult() 
	{
	return GL_MULT;
	}

long CWaiteGLCtrl::glAdd() 
	{
	return GL_ADD;
	}

long CWaiteGLCtrl::glNever() 
	{
	return GL_NEVER;
	}

long CWaiteGLCtrl::glLess() 
	{
	return GL_LESS;
	}

long CWaiteGLCtrl::glEqual() 
	{
	return GL_EQUAL;
	}

long CWaiteGLCtrl::glLequal() 
	{
	return GL_LEQUAL;
	}

long CWaiteGLCtrl::glGreater() 
	{
	return GL_GREATER;
	}

long CWaiteGLCtrl::glNotequal() 
	{
	return GL_NOTEQUAL;
	}

long CWaiteGLCtrl::glGequal() 
	{
	return GL_GEQUAL;
	}

long CWaiteGLCtrl::glAlways() 
	{
	return GL_ALWAYS;	
	}

long CWaiteGLCtrl::glPoints() 
{
	return GL_POINTS;
}

long CWaiteGLCtrl::glLines() 
{
	return GL_LINES;
}

long CWaiteGLCtrl::glLineLoop() 
{
	return GL_LINE_LOOP;
}

long CWaiteGLCtrl::glLineStrip() 
{
	return GL_LINE_STRIP;
}

long CWaiteGLCtrl::glTriangles() 
{
	return GL_TRIANGLES;
}

long CWaiteGLCtrl::glTriangleStrip() 
{
	return GL_TRIANGLE_STRIP;
}

long CWaiteGLCtrl::glTriangleFan() 
{
	return GL_TRIANGLE_FAN;
}

long CWaiteGLCtrl::glQuads() 
{
	return GL_QUADS;
}

long CWaiteGLCtrl::glQuadStrip() 
{
	return GL_QUAD_STRIP;
}

long CWaiteGLCtrl::glPolygon() 
{
	return GL_POLYGON;
}


long CWaiteGLCtrl::glCurrentBit() 
	{
	return GL_CURRENT_BIT;
	}


long CWaiteGLCtrl::glPointbit() 
	{
	return GL_POINT_BIT;
	}

long CWaiteGLCtrl::glLineBit() 
	{
	return GL_LINE_BIT;	
	}

long CWaiteGLCtrl::glPolygonBit() 
	{
	return GL_POLYGON_BIT;
	}

long CWaiteGLCtrl::glPolygonStippleBit() 
	{
	return GL_POLYGON_STIPPLE_BIT;
	}

long CWaiteGLCtrl::glPixelModeBit() 
	{
	return GL_PIXEL_MODE_BIT;
	}

long CWaiteGLCtrl::glLightingBit() 
	{
	return GL_LIGHTING_BIT;
	}

long CWaiteGLCtrl::glFogBit() 
	{
	return GL_FOG_BIT;
	}

long CWaiteGLCtrl::glDepthBufferBit() 
{
	return GL_DEPTH_BUFFER_BIT;
}

long CWaiteGLCtrl::glAccumBufferBit() 
{
	return GL_ACCUM_BUFFER_BIT;
}

long CWaiteGLCtrl::glStencilBufferbit() 
{
	return GL_STENCIL_BUFFER_BIT;
}

long CWaiteGLCtrl::glViewportBit() 
{
	return GL_VIEWPORT_BIT;
}

long CWaiteGLCtrl::glTransformBit() 
{
	return GL_TRANSFORM_BIT;
}

long CWaiteGLCtrl::glEnableBit() 
{
	return GL_ENABLE_BIT;
}

long CWaiteGLCtrl::glHintBit() 
{
	return GL_HINT_BIT;
}

long CWaiteGLCtrl::glEvalBit() 
{
	return GL_EVAL_BIT;
}

long CWaiteGLCtrl::glListBit() 
{
	return GL_LIST_BIT;
}

long CWaiteGLCtrl::glTextureBit() 
{
	return GL_TEXTURE_BIT;
}

long CWaiteGLCtrl::glScissorBit() 
{
	return GL_SCISSOR_BIT;
}

long CWaiteGLCtrl::glAllAttribBits() 
{
	return GL_ALL_ATTRIB_BITS;
}

long CWaiteGLCtrl::glNoError() 
{
	return GL_NO_ERROR;
}

long CWaiteGLCtrl::glInvalidEnum() 
{
	return GL_INVALID_ENUM;
}

long CWaiteGLCtrl::glInvalidValue() 
{
	return GL_INVALID_VALUE;
}

long CWaiteGLCtrl::glInvalidOperation() 
{
	return GL_INVALID_OPERATION;
}

long CWaiteGLCtrl::glStackOverflow() 
{
	return GL_STACK_OVERFLOW;
}

long CWaiteGLCtrl::glStackUnderflow() 
{
	return GL_STACK_UNDERFLOW;
}

long CWaiteGLCtrl::glOutOfMemory() 
{
	return GL_OUT_OF_MEMORY;
}


long CWaiteGLCtrl::glDontCare() 
{
	return GL_DONT_CARE;
}

long CWaiteGLCtrl::glFastest() 
{
	return GL_FASTEST;
}

long CWaiteGLCtrl::glNicest() 
{
	return GL_NICEST;
}

long CWaiteGLCtrl::glLight0() 
{
	return GL_LIGHT0;
}

long CWaiteGLCtrl::glLight1() 
{
	return GL_LIGHT1;
}

long CWaiteGLCtrl::glLight2() 
{
	return GL_LIGHT2;
}

long CWaiteGLCtrl::glLight3() 
{
	return GL_LIGHT3;
}

long CWaiteGLCtrl::glLight4() 
{
	return GL_LIGHT4;
}

long CWaiteGLCtrl::glLight5() 
{
	return GL_LIGHT5;
}

long CWaiteGLCtrl::glLight6() 
{
	return GL_LIGHT6;
}

long CWaiteGLCtrl::glLight7() 
{
	return GL_LIGHT7;
}

long CWaiteGLCtrl::glAmbient() 
{
	return GL_AMBIENT;
}

long CWaiteGLCtrl::glDiffuse() 
{
	return GL_DIFFUSE;
}

long CWaiteGLCtrl::glSpecular() 
{
	return GL_SPECULAR;
}

long CWaiteGLCtrl::glPosition() 
{
	return GL_POSITION;
}

long CWaiteGLCtrl::glSpotDirection() 
{
	return GL_SPOT_DIRECTION;
}

long CWaiteGLCtrl::glSpotExponent() 
{
	return GL_SPOT_EXPONENT;
}

long CWaiteGLCtrl::glSpotCutoff() 
{
	return GL_SPOT_CUTOFF;
}

long CWaiteGLCtrl::glConstantAttenuation() 
{
	return GL_CONSTANT_ATTENUATION;
}

long CWaiteGLCtrl::glLinearAttenuation() 
{
	return GL_LINEAR_ATTENUATION;
}

long CWaiteGLCtrl::glQuadraticAttenuation() 
{
	return GL_QUADRATIC_ATTENUATION;
}


long CWaiteGLCtrl::glEmission() 
{
	return GL_EMISSION;
}

long CWaiteGLCtrl::glShininess() 
{
	return GL_SHININESS;
}

long CWaiteGLCtrl::glAmbientAndDiffuse() 
{
	return GL_AMBIENT_AND_DIFFUSE;
}

long CWaiteGLCtrl::glColorIndexes() 
{
	return GL_COLOR_INDEXES;
}

long CWaiteGLCtrl::glModelview() 
{
	return GL_MODELVIEW;
}

long CWaiteGLCtrl::glProjection() 
{
	return GL_PROJECTION;
}

long CWaiteGLCtrl::glTexture() 
{
	return GL_TEXTURE;
}

long CWaiteGLCtrl::glColor() 
{
	return GL_COLOR;
}

long CWaiteGLCtrl::glDepth() 
{
	return GL_DEPTH;
}

long CWaiteGLCtrl::glStencil() 
{
	return GL_STENCIL;
}


long CWaiteGLCtrl::glFlat() 
	{
	return GL_FLAT;
	}

long CWaiteGLCtrl::glSmooth() 
	{
	return GL_SMOOTH;
	}

long CWaiteGLCtrl::glPoint() 
{
	return GL_POINT;
}

long CWaiteGLCtrl::glLine() 
{
	return GL_LINE;
}

long CWaiteGLCtrl::glFill() 
{
	return GL_FILL;
}

long CWaiteGLCtrl::glCw() 
{
	return GL_CW;
}

long CWaiteGLCtrl::glCcw() 
{
	return GL_CCW;
}

long CWaiteGLCtrl::glCurrentColor() 
{
	return GL_CURRENT_COLOR;
}

long CWaiteGLCtrl::glCurrentIndex() 
{
	return GL_CURRENT_INDEX;
}

long CWaiteGLCtrl::glCurrentNormal() 
{
	return GL_CURRENT_NORMAL;
}

long CWaiteGLCtrl::glCurrentTextureCoords() 
{
	return GL_CURRENT_TEXTURE_COORDS;
}

long CWaiteGLCtrl::glCurrentRasterColor() 
{
	return GL_CURRENT_RASTER_COLOR;
}

long CWaiteGLCtrl::glCurrentRasterIndex() 
{
	return GL_CURRENT_RASTER_INDEX;
}

long CWaiteGLCtrl::glCurrentRasterTextureCoords() 
{
	return GL_CURRENT_RASTER_TEXTURE_COORDS;
}

long CWaiteGLCtrl::glCurrentRasterPosition() 
{
	return GL_CURRENT_RASTER_POSITION;
}

long CWaiteGLCtrl::glCurrentRasterPositionValid() 
{
	return GL_CURRENT_RASTER_POSITION_VALID;
}

long CWaiteGLCtrl::glCurrentRasterDistance() 
{
	return GL_CURRENT_RASTER_DISTANCE;
}

long CWaiteGLCtrl::glPointSmooth() 
{
	return GL_POINT_SMOOTH;
}

long CWaiteGLCtrl::glPointSize() 
{
	return GL_POINT_SIZE;
}

long CWaiteGLCtrl::glPointSizeRange() 
{
	return GL_POINT_SIZE_RANGE;
}

long CWaiteGLCtrl::glPointSizeGranularity() 
{
	return GL_POINT_SIZE_GRANULARITY;
}

long CWaiteGLCtrl::glLineSmooth() 
{
	return GL_LINE_SMOOTH;
}

long CWaiteGLCtrl::glLineWidth() 
{
	return GL_LINE_WIDTH;
}

long CWaiteGLCtrl::glLineWidthRange() 
{
	return GL_LINE_WIDTH_RANGE;
}

long CWaiteGLCtrl::glLineWidthGranularity() 
{
	return GL_LINE_WIDTH_GRANULARITY;
}

long CWaiteGLCtrl::glLineStipple() 
{
	return GL_LINE_STIPPLE;
}

long CWaiteGLCtrl::glLineStipplePattern() 
{
	return GL_LINE_STIPPLE_PATTERN;
}

long CWaiteGLCtrl::glLineStippleRepeat() 
{
	return GL_LINE_STIPPLE_REPEAT;
}

long CWaiteGLCtrl::glListMode() 
{
	return GL_LIST_MODE;
}

long CWaiteGLCtrl::glMaxListNesting() 
{
	return GL_MAX_LIST_NESTING;
}

long CWaiteGLCtrl::glListBase() 
{
	return GL_LIST_BASE;
}

long CWaiteGLCtrl::glListIndex() 
{
	return GL_LIST_INDEX;
}

long CWaiteGLCtrl::glPolygonMode() 
{
	return GL_POLYGON_MODE;
}

long CWaiteGLCtrl::glPolygonSmooth() 
{
	return GL_POLYGON_SMOOTH;
}

long CWaiteGLCtrl::glPolygonStipple() 
{
	return GL_POLYGON_STIPPLE;
}

long CWaiteGLCtrl::glEdgeFlag() 
{
	return GL_EDGE_FLAG;
}

long CWaiteGLCtrl::glCullFace() 
{
	return GL_CULL_FACE;
}

long CWaiteGLCtrl::glCullFaceMode() 
{
	return GL_CULL_FACE_MODE;
}

long CWaiteGLCtrl::glFrontFace() 
{
	return GL_FRONT_FACE;
}

long CWaiteGLCtrl::glLighting() 
{
	return GL_LIGHTING;
}

long CWaiteGLCtrl::glLightModelLocalViewer() 
{
	return GL_LIGHT_MODEL_LOCAL_VIEWER;
}

long CWaiteGLCtrl::glLightModelTwoSide() 
{
	return GL_LIGHT_MODEL_TWO_SIDE;
}

long CWaiteGLCtrl::glLightModelAmbient() 
{
	return GL_LIGHT_MODEL_AMBIENT;
}

long CWaiteGLCtrl::glShadeModel() 
{
	return GL_SHADE_MODEL;
}

long CWaiteGLCtrl::glColorMaterialFace() 
{
	return GL_COLOR_MATERIAL_FACE;
}

long CWaiteGLCtrl::glColorMaterialParameter() 
{
	return GL_COLOR_MATERIAL_PARAMETER;
}

long CWaiteGLCtrl::glColorMaterial() 
{
	return GL_COLOR_MATERIAL;
}

long CWaiteGLCtrl::glFog() 
{
	return GL_FOG;
}

long CWaiteGLCtrl::glFogIndex() 
{
	return GL_FOG_INDEX;
}

long CWaiteGLCtrl::glFogDensity() 
{
	return GL_FOG_DENSITY;
}

long CWaiteGLCtrl::glFogStart() 
{
	return GL_FOG_START;
}

long CWaiteGLCtrl::glFogEnd() 
{
	return GL_FOG_END;
}

long CWaiteGLCtrl::glFogMode() 
{
	return GL_FOG_MODE;
}

long CWaiteGLCtrl::glFogColor() 
{
	return GL_FOG_COLOR;
}

long CWaiteGLCtrl::glDepthRange() 
{
	return GL_DEPTH_RANGE;
}

long CWaiteGLCtrl::glDepthTest() 
{
	return GL_DEPTH_TEST;
}

long CWaiteGLCtrl::glDepthWritemask() 
{
	return GL_DEPTH_WRITEMASK;
}

long CWaiteGLCtrl::glDepthClearValue() 
{
	return GL_DEPTH_CLEAR_VALUE;
}

long CWaiteGLCtrl::glDepthFunc() 
{
	return GL_DEPTH_FUNC;
}

long CWaiteGLCtrl::glAccumClearValue() 
{
	return GL_ACCUM_CLEAR_VALUE;
}

long CWaiteGLCtrl::glStencilTest() 
{
	return GL_STENCIL_TEST;
}

long CWaiteGLCtrl::glStencilClearValue() 
{
	return GL_STENCIL_CLEAR_VALUE;
}

long CWaiteGLCtrl::glStencilFunc() 
{
	return GL_STENCIL_FUNC;
}

long CWaiteGLCtrl::glStencilValueMask() 
{
	return GL_STENCIL_VALUE_MASK;
}

long CWaiteGLCtrl::glStencilFail() 
{
	return GL_STENCIL_FAIL;
}

long CWaiteGLCtrl::glStencilPassDepthFail() 
{
	return GL_STENCIL_PASS_DEPTH_FAIL;
}

long CWaiteGLCtrl::glStencilPassDepthPass() 
{
	return GL_STENCIL_PASS_DEPTH_PASS;
}

long CWaiteGLCtrl::glStencilRef() 
{
	return GL_STENCIL_REF;
}

long CWaiteGLCtrl::glStencilWritemask() 
{
	return GL_STENCIL_WRITEMASK;
}

long CWaiteGLCtrl::glMatrixMode() 
{
	return GL_MATRIX_MODE;
}

long CWaiteGLCtrl::glNormalize() 
{
	return GL_NORMALIZE;
}

long CWaiteGLCtrl::glViewport() 
{
	return GL_VIEWPORT;
}

long CWaiteGLCtrl::glModelviewStackDepth() 
{
	return GL_MODELVIEW_STACK_DEPTH;
}

long CWaiteGLCtrl::glProjectionStackDepth() 
{
	return GL_PROJECTION_STACK_DEPTH;
}

long CWaiteGLCtrl::glTextureStackDepth() 
{
	return GL_TEXTURE_STACK_DEPTH;
}

long CWaiteGLCtrl::glModelviewMatrix() 
{
	return GL_MODELVIEW_MATRIX;
}

long CWaiteGLCtrl::glProjectionMatrix() 
{
	return GL_PROJECTION_MATRIX;
}

long CWaiteGLCtrl::glTextureMatrix() 
{
	return GL_TEXTURE_MATRIX;
}

long CWaiteGLCtrl::glAttribStackDepth() 
{
	return GL_ATTRIB_STACK_DEPTH;
}

long CWaiteGLCtrl::glCompile() 
{
	return GL_COMPILE;
}

long CWaiteGLCtrl::glCompileAndExecute() 
{
	return GL_COMPILE_AND_EXECUTE;
}

long CWaiteGLCtrl::glBitmap() 
{
	return GL_BITMAP;
}

long CWaiteGLCtrl::glRender() 
{
	return GL_RENDER;
}

long CWaiteGLCtrl::glFeedback() 
{
	return GL_FEEDBACK;
}

long CWaiteGLCtrl::glSelect() 
{
	return GL_SELECT;
}

long CWaiteGLCtrl::glAlphaTest() 
{
	return GL_ALPHA_TEST;
}

long CWaiteGLCtrl::glAlphaTestFunc() 
{
	return GL_ALPHA_TEST_FUNC;
}

long CWaiteGLCtrl::glAlphaTestRef() 
{
	return GL_ALPHA_TEST_REF;
}

long CWaiteGLCtrl::glDither() 
{
	return GL_DITHER;
}


long CWaiteGLCtrl::glClamp() 
	{
	return GL_CLAMP;
	}

long CWaiteGLCtrl::glRepeat() 
	{
	return GL_REPEAT;
	}

long CWaiteGLCtrl::glNearest() 
	{
	return GL_NEAREST;
	}

long CWaiteGLCtrl::glLinear() 
	{
	return GL_LINEAR;
	}

long CWaiteGLCtrl::glVendor() 
{
	return GL_VENDOR;
}

long CWaiteGLCtrl::glRenderer() 
{
	return GL_RENDERER;
}

long CWaiteGLCtrl::glVersion() 
{
	return GL_VERSION;
}

long CWaiteGLCtrl::glExtensions() 
{
	return GL_EXTENSIONS;
}

long CWaiteGLCtrl::glTextureMagFilter() 
{
return GL_TEXTURE_MAG_FILTER;
}

long CWaiteGLCtrl::glTextureMinFilter() 
{
	return GL_TEXTURE_MIN_FILTER;
}

long CWaiteGLCtrl::glTextureWrapS() 
{
	return GL_TEXTURE_WRAP_S;
}

long CWaiteGLCtrl::glTextureWrapT() 
{
	return GL_TEXTURE_WRAP_T;
}

long CWaiteGLCtrl::glNearestMipmapNearest() 
{
	return GL_NEAREST_MIPMAP_NEAREST;
}

long CWaiteGLCtrl::glLinearMipmapNearest() 
{
	return GL_LINEAR_MIPMAP_NEAREST;
}

long CWaiteGLCtrl::glNearestMipmapLinear() 
{
	return GL_NEAREST_MIPMAP_LINEAR;
}

long CWaiteGLCtrl::glLinearMipmapLinear() 
{
	return GL_LINEAR_MIPMAP_LINEAR;
}


long CWaiteGLCtrl::glKeep() 
{
	return GL_KEEP;
}

long CWaiteGLCtrl::glReplace() 
{
	return GL_REPLACE;
}

long CWaiteGLCtrl::glIncr() 
{
	return GL_INCR;
}

long CWaiteGLCtrl::glDecr() 
{
	return GL_DECR;
}

long CWaiteGLCtrl::glS() 
{
	return GL_S;
}

long CWaiteGLCtrl::glT() 
{
	return GL_T;
}

long CWaiteGLCtrl::glR() 
{
	return GL_R;
}

long CWaiteGLCtrl::glQ() 
{
	return GL_Q;
}

long CWaiteGLCtrl::glModulate() 
{
	return GL_MODULATE;
}

long CWaiteGLCtrl::glDecal() 
{
	return GL_DECAL;
}

long CWaiteGLCtrl::glTextureEnvMode() 
{
	return GL_TEXTURE_ENV_MODE;
}

long CWaiteGLCtrl::glTextureEnvColor() 
{
	return GL_TEXTURE_ENV_COLOR;
}

long CWaiteGLCtrl::glTextureEnv() 
{
	return GL_TEXTURE_ENV;
}

long CWaiteGLCtrl::glEyeLinear() 
{
	return GL_EYE_LINEAR;
}

long CWaiteGLCtrl::glObjectLinear() 
{
	return GL_OBJECT_LINEAR;
}

long CWaiteGLCtrl::glSphereMap() 
{
	return GL_SPHERE_MAP;
}

long CWaiteGLCtrl::glTextureGenMode() 
{
	return GL_TEXTURE_GEN_MODE;
}

long CWaiteGLCtrl::glObjectPlane() 
{
	return GL_OBJECT_PLANE;
}

long CWaiteGLCtrl::glEyePlane() 
{
	return GL_EYE_PLANE;
}

long CWaiteGLCtrl::glZero() 
	{
	return GL_ZERO;
	}

long CWaiteGLCtrl::glOne() 
{
	return GL_ONE;
}

long CWaiteGLCtrl::glSrcColor() 
	{
	return GL_SRC_COLOR;
	}

long CWaiteGLCtrl::glOneMinusSrcColor() 
{
	return GL_ONE_MINUS_SRC_COLOR;
}

long CWaiteGLCtrl::glSrcAlpha() 
	{
	return GL_SRC_ALPHA;
	}

long CWaiteGLCtrl::glOneMinusSrcAlpha() 
{
	return GL_ONE_MINUS_SRC_ALPHA;
}

long CWaiteGLCtrl::glDstAlpha() 
{
	return GL_ONE_MINUS_SRC_ALPHA;
}

long CWaiteGLCtrl::glOneMinusDstAlpha() 
{
	return GL_ONE_MINUS_DST_ALPHA;
}

long CWaiteGLCtrl::glDstColor() 
{
	return GL_DST_COLOR;
}

long CWaiteGLCtrl::glOneMinusDstColor() 
{
	return GL_ONE_MINUS_DST_COLOR;
}

long CWaiteGLCtrl::glSrcAlphaSaturate() 
{
	return GL_SRC_ALPHA_SATURATE;
}

long CWaiteGLCtrl::glClipPlane0() 
{
	return GL_CLIP_PLANE0;
}

long CWaiteGLCtrl::glClipPlane1() 
{
	return GL_CLIP_PLANE1;
}

long CWaiteGLCtrl::glClipPlane2() 
{
	return GL_CLIP_PLANE2;
}

long CWaiteGLCtrl::glClipPlane3() 
{
	return GL_CLIP_PLANE3;
}

long CWaiteGLCtrl::glClipPlane4() 
{
	return GL_CLIP_PLANE4;
}

long CWaiteGLCtrl::glClipPlane5() 
{
	return GL_CLIP_PLANE5;
}


long CWaiteGLCtrl::glNone() 
{
	return GL_NONE;
}

long CWaiteGLCtrl::glFrontLeft() 
{
	return GL_FRONT_LEFT;
}

long CWaiteGLCtrl::glFrontRight() 
{
	return GL_FRONT_RIGHT;
}

long CWaiteGLCtrl::glBackLeft() 
{
	return GL_BACK_LEFT;
}

long CWaiteGLCtrl::glBackRight() 
{
	return GL_BACK_RIGHT;
}

long CWaiteGLCtrl::glFront() 
{
	return GL_FRONT;
}

long CWaiteGLCtrl::glBack() 
{
	return GL_BACK;
}

long CWaiteGLCtrl::glLeft() 
{
	return GL_LEFT;
}

long CWaiteGLCtrl::glRight() 
{
	return GL_RIGHT;
}

long CWaiteGLCtrl::glFrontAndBack() 
{
	return GL_FRONT_AND_BACK;
}

long CWaiteGLCtrl::glAux0() 
{
	return GL_AUX0;
}

long CWaiteGLCtrl::glAux1() 
{
	return GL_AUX1;
}

long CWaiteGLCtrl::glAux2() 
{
	return GL_AUX2;
}

long CWaiteGLCtrl::glAux3() 
{
	return GL_AUX3;
}

long CWaiteGLCtrl::gl2d() 
{
	return GL_2D;
}

long CWaiteGLCtrl::gl3d() 
{
	return GL_3D;
}

long CWaiteGLCtrl::gl3dColor() 
{
	return GL_3D_COLOR;
}

long CWaiteGLCtrl::gl3dColorTexture() 
{
	return GL_3D_COLOR_TEXTURE;
}

long CWaiteGLCtrl::gl4dColorTexture() 
{
	return GL_4D_COLOR_TEXTURE;
}


long CWaiteGLCtrl::glPassThroughToken() 
{
	return GL_PASS_THROUGH_TOKEN;
}

long CWaiteGLCtrl::glPointToken() 
{
	return GL_POINT_TOKEN;
}

long CWaiteGLCtrl::glLineToken() 
{
	return GL_LINE_TOKEN;
}

long CWaiteGLCtrl::glPolygonToken() 
{
	return GL_POLYGON_TOKEN;
}


long CWaiteGLCtrl::glBitmapToken() 
{
	return GL_BITMAP_TOKEN;
}

long CWaiteGLCtrl::glDrawPixelToken() 
{
	return GL_DRAW_PIXEL_TOKEN;
}

long CWaiteGLCtrl::glCopyPixelToken() 
{
	return GL_COPY_PIXEL_TOKEN;
}

long CWaiteGLCtrl::glLineResetToken() 
{
	return GL_LINE_RESET_TOKEN;
}

long CWaiteGLCtrl::glExp() 
{
	return GL_EXP;
}

long CWaiteGLCtrl::glExp2() 
{
	return GL_EXP2;
}

long CWaiteGLCtrl::glCoeff() 
{
	return GL_COEFF;
}

long CWaiteGLCtrl::glOrder() 
{
	return GL_ORDER;
}

long CWaiteGLCtrl::glDomain() 
{
	return GL_DOMAIN;
}

long CWaiteGLCtrl::glBlendDst() 
{
	return GL_BLEND_DST;
}

long CWaiteGLCtrl::glBlendSrc() 
{
	return GL_BLEND_SRC;
}

long CWaiteGLCtrl::glBlend() 
{
	return GL_BLEND;
}

long CWaiteGLCtrl::glLogicOpMode() 
{
	return GL_LOGIC_OP_MODE;
}

long CWaiteGLCtrl::glLogicOp() 
{
	return GL_LOGIC_OP;
}

long CWaiteGLCtrl::glAuxBuffers() 
{
	return GL_AUX_BUFFERS;
}

long CWaiteGLCtrl::glDrawBuffer() 
{
	return GL_DRAW_BUFFER;
}

long CWaiteGLCtrl::glReadBuffer() 
{
	return GL_READ_BUFFER;
}

long CWaiteGLCtrl::glScissorBox() 
{
	return GL_SCISSOR_BOX;
}

long CWaiteGLCtrl::glScissorTest() 
{
	return GL_SCISSOR_TEST;
}

long CWaiteGLCtrl::glIndexClearValue() 
{
	return GL_INDEX_CLEAR_VALUE;
}

long CWaiteGLCtrl::glIndexWritemask() 
{
	return GL_INDEX_WRITEMASK;
}

long CWaiteGLCtrl::glColorClearValue() 
{
	return GL_COLOR_CLEAR_VALUE;
}

long CWaiteGLCtrl::glColorWritemask() 
{
	return GL_COLOR_WRITEMASK;
}

long CWaiteGLCtrl::glIndexMode() 
{
	return GL_INDEX_MODE;
}

long CWaiteGLCtrl::glRgbaMode() 
{
	return GL_RGBA_MODE;
}


long CWaiteGLCtrl::glStereo() 
{
	return GL_STEREO;
}

long CWaiteGLCtrl::glRenderMode() 
{
	return GL_RENDER_MODE;
}

long CWaiteGLCtrl::glPerspectiveCorrectionHint() 
{
	return GL_PERSPECTIVE_CORRECTION_HINT;
}

long CWaiteGLCtrl::glPointSmoothHint() 
{
	return GL_POINT_SMOOTH_HINT;
}

long CWaiteGLCtrl::glLineSmoothHint() 
{
	return GL_LINE_SMOOTH_HINT;
}

long CWaiteGLCtrl::glPolygonSmoothHint() 
{
	return GL_POLYGON_SMOOTH_HINT;
}

long CWaiteGLCtrl::glFogHint() 
{
	return GL_FOG_HINT;
}

long CWaiteGLCtrl::glTextureGenS() 
{
	return GL_TEXTURE_GEN_S;
}

long CWaiteGLCtrl::glTextureGenT() 
{
	return GL_TEXTURE_GEN_T;
}

long CWaiteGLCtrl::glTextureGenR() 
{
	return GL_TEXTURE_GEN_R;
}

long CWaiteGLCtrl::glTextureGenQ() 
{
	return GL_TEXTURE_GEN_Q;
}

long CWaiteGLCtrl::glPixelMapIToI() 
{
	return GL_PIXEL_MAP_I_TO_I;
}

long CWaiteGLCtrl::glPixelMapSToS() 
{
	return GL_PIXEL_MAP_S_TO_S;
}

long CWaiteGLCtrl::glPixelMapIToR() 
{
	return GL_PIXEL_MAP_I_TO_R;
}

long CWaiteGLCtrl::glPixelMapIToG() 
{
	return GL_PIXEL_MAP_I_TO_G;
}

long CWaiteGLCtrl::glPixelMapIToB() 
{
	return GL_PIXEL_MAP_I_TO_B;
}

long CWaiteGLCtrl::glPixelMapIToA() 
{
	return GL_PIXEL_MAP_I_TO_A;
}

long CWaiteGLCtrl::glPixelMapRToR() 
{
	return GL_PIXEL_MAP_R_TO_R;
}

long CWaiteGLCtrl::glPixelMapGToG() 
{
	return GL_PIXEL_MAP_G_TO_G;
}

long CWaiteGLCtrl::glPixelMapBToB() 
{
	return GL_PIXEL_MAP_B_TO_B;
}

long CWaiteGLCtrl::glPixelMapAToA() 
{
	return GL_PIXEL_MAP_A_TO_A;
}

long CWaiteGLCtrl::glPixelMapIToISize() 
{
	return GL_PIXEL_MAP_I_TO_I_SIZE;
}

long CWaiteGLCtrl::glPixelMapSToSSize() 
{
	return GL_PIXEL_MAP_S_TO_S_SIZE;
}

long CWaiteGLCtrl::glPixelMapIToRSize() 
{
	return GL_PIXEL_MAP_I_TO_R_SIZE;
}

long CWaiteGLCtrl::glPixelMapIToGSize() 
{
	return GL_PIXEL_MAP_I_TO_G_SIZE;
}

long CWaiteGLCtrl::glPixelMapIToBSize() 
{
	return GL_PIXEL_MAP_I_TO_B_SIZE;
}

long CWaiteGLCtrl::glPixelMapIToASize() 
{
	return GL_PIXEL_MAP_I_TO_A_SIZE;
}

long CWaiteGLCtrl::glPixelMapRToRSize() 
{
	return GL_PIXEL_MAP_R_TO_R_SIZE;
}

long CWaiteGLCtrl::glPixelMapGToGSize() 
{
	return GL_PIXEL_MAP_G_TO_G_SIZE;
}

long CWaiteGLCtrl::glPixelMapBToBSize() 
{
	return GL_PIXEL_MAP_B_TO_B_SIZE;
}

long CWaiteGLCtrl::glPixelMapAToASize() 
{
	return GL_PIXEL_MAP_A_TO_A_SIZE;
}

long CWaiteGLCtrl::glUnpackSwapBytes() 
{
	return GL_UNPACK_SWAP_BYTES;
}

long CWaiteGLCtrl::glUnpackLsbFirst() 
{
	return GL_UNPACK_LSB_FIRST;
}

long CWaiteGLCtrl::glUnpackRowLength() 
{
	return GL_UNPACK_ROW_LENGTH;
}

long CWaiteGLCtrl::glUnpackSkipRows() 
{
	return GL_UNPACK_SKIP_ROWS;
}

long CWaiteGLCtrl::glUnpackSkipPixels() 
{
	return GL_UNPACK_SKIP_PIXELS;
}

long CWaiteGLCtrl::glUnpackAlignment() 
{
	return GL_UNPACK_ALIGNMENT;
}

long CWaiteGLCtrl::glPackSwapBytes() 
{
	return GL_PACK_SWAP_BYTES;
}

long CWaiteGLCtrl::glPackLsbFirst() 
{
	return GL_PACK_LSB_FIRST;
}

long CWaiteGLCtrl::glPackRowLength() 
{
	return GL_PACK_ROW_LENGTH;
}

long CWaiteGLCtrl::glPackSkipRows() 
{
	return GL_PACK_SKIP_ROWS;
}

long CWaiteGLCtrl::glPackSkipPixels() 
{
	return GL_PACK_SKIP_PIXELS;
}

long CWaiteGLCtrl::glPackAlignment() 
{
	return GL_PACK_ALIGNMENT;
}

long CWaiteGLCtrl::glMapColor() 
{
	return GL_MAP_COLOR;
}

long CWaiteGLCtrl::glMapStencil() 
{
	return GL_MAP_STENCIL;
}

long CWaiteGLCtrl::glIndexShift() 
{
	return GL_INDEX_SHIFT;
}

long CWaiteGLCtrl::glIndexOffset() 
{
	return GL_INDEX_OFFSET;
}

long CWaiteGLCtrl::glRedScale() 
{
	return GL_RED_SCALE;
}

long CWaiteGLCtrl::glRedBias() 
{
	return GL_RED_BIAS;
}

long CWaiteGLCtrl::glZoomX() 
{
	return GL_ZOOM_X;
}

long CWaiteGLCtrl::glZoomY() 
{
	return GL_ZOOM_Y;
}

long CWaiteGLCtrl::glGreenScale() 
{
	return GL_GREEN_SCALE;
}

long CWaiteGLCtrl::glGreenBias() 
{
	return GL_GREEN_BIAS;
}

long CWaiteGLCtrl::glBlueScale() 
{
	return GL_BLUE_SCALE;
}

long CWaiteGLCtrl::glBlueBias() 
{
	return GL_BLUE_BIAS;
}

long CWaiteGLCtrl::glAlphaScale() 
{
	return GL_ALPHA_SCALE;
}

long CWaiteGLCtrl::glAlphaBias() 
{
	return GL_ALPHA_BIAS;
}

long CWaiteGLCtrl::glDepthScale() 
{
	return GL_DEPTH_SCALE;
}

long CWaiteGLCtrl::glDepthBias() 
{
	return GL_DEPTH_BIAS;
}

long CWaiteGLCtrl::glMaxEvalOrder() 
{
	return GL_MAX_EVAL_ORDER;
}

long CWaiteGLCtrl::glMaxLights() 
{
	return GL_MAX_LIGHTS;
}

long CWaiteGLCtrl::glMaxClipPlanes() 
{
	return GL_MAX_CLIP_PLANES;
}

long CWaiteGLCtrl::glMaxTextureSize() 
{
	return GL_MAX_TEXTURE_SIZE;
}

long CWaiteGLCtrl::glMaxPixelMapTable() 
{
	return GL_MAX_PIXEL_MAP_TABLE;
}

long CWaiteGLCtrl::glMaxAttribStackDepth() 
{
	return GL_MAX_ATTRIB_STACK_DEPTH;
}

long CWaiteGLCtrl::glMaxModelviewStackDepth() 
{
	return GL_MAX_MODELVIEW_STACK_DEPTH;
}

long CWaiteGLCtrl::glMaxNameStackDepth() 
{
	return GL_MAX_NAME_STACK_DEPTH;
}

long CWaiteGLCtrl::glMaxProjectionStackDepth() 
{
	return GL_MAX_PROJECTION_STACK_DEPTH;
}


long CWaiteGLCtrl::glMaxTextureStackDepth() 
{
	return GL_MAX_TEXTURE_STACK_DEPTH;
}

long CWaiteGLCtrl::glMaxViewportDims() 
{
	return GL_MAX_VIEWPORT_DIMS;
}

long CWaiteGLCtrl::glSubpixelBits() 
{
	return GL_SUBPIXEL_BITS;
}

long CWaiteGLCtrl::glIndexBits() 
{
	return GL_INDEX_BITS;
}

long CWaiteGLCtrl::glRedBits() 
{
	return GL_RED_BITS;
}

long CWaiteGLCtrl::glGreenBits() 
{
	return GL_GREEN_BITS;
}

long CWaiteGLCtrl::glBlueBits() 
{
	return GL_BLUE_BITS;
}

long CWaiteGLCtrl::glAlphaBits() 
{
	return GL_ALPHA_BITS;
}

long CWaiteGLCtrl::glDepthBits() 
{
	return GL_DEPTH_BITS;
}

long CWaiteGLCtrl::glStencilBits() 
{
	return GL_STENCIL_BITS;
}

long CWaiteGLCtrl::glAccumRedBits() 
{
	return GL_ACCUM_RED_BITS;
}

long CWaiteGLCtrl::glAccumGreenBits() 
{
	return GL_ACCUM_GREEN_BITS;
}

long CWaiteGLCtrl::glAccumBlueBits() 
{
	return GL_ACCUM_BLUE_BITS;
}

long CWaiteGLCtrl::glAccumAlphaBits() 
{
	return GL_ACCUM_ALPHA_BITS;
}

long CWaiteGLCtrl::glNameStackDepth() 
{
	return GL_NAME_STACK_DEPTH;
}

long CWaiteGLCtrl::glAutoNormal() 
{
	return GL_AUTO_NORMAL;
}

long CWaiteGLCtrl::glMap1Color4() 
{
	return GL_MAP1_COLOR_4;
}

long CWaiteGLCtrl::glMap1Index() 
{
	return GL_MAP1_INDEX;
}

long CWaiteGLCtrl::glMap1Normal() 
{
	return GL_MAP1_NORMAL;
}

long CWaiteGLCtrl::glMap1TextureCoord1() 
{
	return GL_MAP1_TEXTURE_COORD_1;
}

long CWaiteGLCtrl::glMap1TextureCoord2() 
{
	return GL_MAP1_TEXTURE_COORD_2;
}

long CWaiteGLCtrl::glMap1TextureCoord3() 
{
	return GL_MAP1_TEXTURE_COORD_3;
}

long CWaiteGLCtrl::glMap1TextureCoord4() 
{
	return GL_MAP1_TEXTURE_COORD_4;
}

long CWaiteGLCtrl::glMap1Vertex3() 
{
	return GL_MAP1_VERTEX_3;
}

long CWaiteGLCtrl::glMap1Vertex4() 
{
	return GL_MAP1_VERTEX_4;
}

long CWaiteGLCtrl::glMap2Color4() 
{
	return GL_MAP2_COLOR_4;
}

long CWaiteGLCtrl::glMap2Index() 
{
	return GL_MAP2_INDEX;
}

long CWaiteGLCtrl::glMap2Normal() 
{
	return GL_MAP2_NORMAL;
}

long CWaiteGLCtrl::glMap2TextureCoord1() 
{
	return GL_MAP2_TEXTURE_COORD_1;
}

long CWaiteGLCtrl::glMap2TextureCoord2() 
{
	return GL_MAP2_TEXTURE_COORD_2;
}

long CWaiteGLCtrl::glMap2TextureCoord3() 
{
	return GL_MAP2_TEXTURE_COORD_3;
}

long CWaiteGLCtrl::glMap2TextureCoord4() 
{
	return GL_MAP2_TEXTURE_COORD_4;
}

long CWaiteGLCtrl::glMap2Vertex3() 
{
	return GL_MAP2_VERTEX_3;
}

long CWaiteGLCtrl::glMap2Vertex4() 
{
	return GL_MAP2_VERTEX_4;
}

long CWaiteGLCtrl::glMap1GridDomain() 
{
	return GL_MAP1_GRID_DOMAIN;
}

long CWaiteGLCtrl::glMap1GridSegments() 
{
	return GL_MAP1_GRID_SEGMENTS;
}

long CWaiteGLCtrl::glMap2GridDomain() 
{
	return GL_MAP2_GRID_DOMAIN;
}

long CWaiteGLCtrl::glMap2GridSegments() 
{
	return GL_MAP2_GRID_SEGMENTS;
}

long CWaiteGLCtrl::glTexture1d() 
{
	return GL_TEXTURE_1D;
}

long CWaiteGLCtrl::glTexture2d() 
{
	return GL_TEXTURE_2D;
}

long CWaiteGLCtrl::glTextureWidth() 
{
	return GL_TEXTURE_WIDTH;
}

long CWaiteGLCtrl::glTextureHeight() 
{
	return GL_TEXTURE_HEIGHT;
}

long CWaiteGLCtrl::glTextureComponents() 
{
	return GL_TEXTURE_COMPONENTS;
}

long CWaiteGLCtrl::glTextureBorderColor() 
{
	return GL_TEXTURE_BORDER_COLOR;
}

long CWaiteGLCtrl::glTextureBorder() 
{
	return GL_TEXTURE_BORDER;
}

long CWaiteGLCtrl::glByte() 
{
	return GL_BYTE;
}

long CWaiteGLCtrl::glUnsignedByte() 
{
	return GL_UNSIGNED_BYTE;
}

long CWaiteGLCtrl::glShort() 
{
	return GL_SHORT;
}

long CWaiteGLCtrl::glUnsignedShort() 
{
	return GL_UNSIGNED_SHORT;
}

long CWaiteGLCtrl::glInt() 
{
	return GL_INT;
}

long CWaiteGLCtrl::glUnsignedInt() 
{
	return GL_UNSIGNED_INT;
}

long CWaiteGLCtrl::glFloat() 
{
	return GL_FLOAT;
}

long CWaiteGLCtrl::gl2Bytes() 
{
	return GL_2_BYTES;
}

long CWaiteGLCtrl::gl3Bytes() 
{
	return GL_3_BYTES;
}

long CWaiteGLCtrl::gl4Bytes() 
{
	return GL_4_BYTES;
}

long CWaiteGLCtrl::glDoubleExt() 
{
	return GL_DOUBLE_EXT;
}

long CWaiteGLCtrl::glClear() 
{
	return GL_CLEAR;
}

long CWaiteGLCtrl::glAnd() 
{
	return GL_AND;
}

long CWaiteGLCtrl::glAndReverse() 
{
	return GL_AND_REVERSE;
}

long CWaiteGLCtrl::glCopy() 
{
	return GL_COPY;
}

long CWaiteGLCtrl::glAndInverted() 
{
	return GL_AND_INVERTED;
}

long CWaiteGLCtrl::glNoop() 
{
	return GL_NOOP;
}

long CWaiteGLCtrl::glXor() 
{
	return GL_XOR;
}

long CWaiteGLCtrl::glOr() 
{
	return GL_OR;
}

long CWaiteGLCtrl::glNor() 
{
	return GL_NOR;
}

long CWaiteGLCtrl::glEquiv() 
{
	return GL_EQUIV;
}

long CWaiteGLCtrl::glInvert() 
{
	return GL_INVERT;
}

long CWaiteGLCtrl::glOrReverse() 
{
	return GL_OR_REVERSE;
}

long CWaiteGLCtrl::glCopyInverted() 
{
	return GL_COPY_INVERTED;
}

long CWaiteGLCtrl::glOrInverted() 
{
	return GL_OR_INVERTED;
}

long CWaiteGLCtrl::glNand() 
{
	return GL_NAND;
}

long CWaiteGLCtrl::glSet() 
{
	return GL_SET;
}

long CWaiteGLCtrl::glDoublebuffer() 
{
	return GL_DOUBLEBUFFER;
}

long CWaiteGLCtrl::glColorIndex() 
{
	return GL_COLOR_INDEX;
}

long CWaiteGLCtrl::glStencilIndex() 
{
	return GL_STENCIL_INDEX;
}

long CWaiteGLCtrl::glDepthComponent() 
{
	return GL_DEPTH_COMPONENT;
}

long CWaiteGLCtrl::glRed() 
{
	return GL_RED;
}

long CWaiteGLCtrl::glGreen() 
{
	return GL_GREEN;
}

long CWaiteGLCtrl::glBlue() 
{
	return GL_BLUE;
}

long CWaiteGLCtrl::glAlpha() 
{
	return GL_ALPHA;
}

long CWaiteGLCtrl::glRgb() 
{
	return GL_RGB;
}

long CWaiteGLCtrl::glRgba() 
{
	return GL_RGBA;
}

long CWaiteGLCtrl::glLuminance() 
{
	return GL_LUMINANCE;
}

long CWaiteGLCtrl::glLuminanceAlpha() 
{
	return GL_LUMINANCE_ALPHA;
}



/////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////
// GLU FLAGS

long CWaiteGLCtrl::gluVersion() 
	{
	return GLU_VERSION;
	}

long CWaiteGLCtrl::gluExtensions() 
	{
	return GLU_EXTENSIONS;
	}


long CWaiteGLCtrl::gluInvalidEnum() 
{
	return GLU_INVALID_ENUM;
}

long CWaiteGLCtrl::gluInvalidValue() 
{
	return GLU_INVALID_VALUE;
}

long CWaiteGLCtrl::gluOutOfMemory() 
{
	return GLU_OUT_OF_MEMORY;
}

long CWaiteGLCtrl::gluIncompatibleGlVersion() 
{
	return GLU_INCOMPATIBLE_GL_VERSION;
}

long CWaiteGLCtrl::gluSmooth() 
{
	return GL_SMOOTH;
}

long CWaiteGLCtrl::gluFlat() 
{
	return GLU_FLAT;
}

long CWaiteGLCtrl::gluNone() 
{
	return GLU_NONE;
}

long CWaiteGLCtrl::gluPoint() 
{
	return GLU_POINT;
}

long CWaiteGLCtrl::gluLine() 
{
	return GLU_LINE;
}

long CWaiteGLCtrl::gluFill() 
{
	return GLU_FILL;
}

long CWaiteGLCtrl::gluSilhouette() 
{
	return GLU_SILHOUETTE;
}

long CWaiteGLCtrl::gluOutside() 
{
	return GLU_OUTSIDE;
}

long CWaiteGLCtrl::gluInside() 
{
	return GLU_INSIDE;
}

double CWaiteGLCtrl::gluTessMaxCoord() 
{
	return (double)GLU_TESS_MAX_COORD;
}

long CWaiteGLCtrl::gluTessWindingRule() 
{
	return GLU_TESS_WINDING_RULE;
}

long CWaiteGLCtrl::gluTessBoundaryOnly() 
{
	return GLU_TESS_BOUNDARY_ONLY;
}

long CWaiteGLCtrl::gluTessTolerance() 
{
	return GLU_TESS_TOLERANCE;
}

long CWaiteGLCtrl::gluTessWindingOdd() 
{
	return GLU_TESS_WINDING_ODD;
}

long CWaiteGLCtrl::gluTessWindingNonzero() 
{
	return GLU_TESS_WINDING_NONZERO;
}

long CWaiteGLCtrl::gluTessWindingPositive() 
{
	return GLU_TESS_WINDING_POSITIVE;
}

long CWaiteGLCtrl::gluTessWindingNegative() 
{
	return GLU_TESS_WINDING_NEGATIVE;
}

long CWaiteGLCtrl::gluTessWindingAbsGeqTwo() 
{
	return GLU_TESS_WINDING_ABS_GEQ_TWO;
}

long CWaiteGLCtrl::gluTessBegin() 
{
	return GLU_TESS_BEGIN;
}

long CWaiteGLCtrl::gluTessVertex() 
{
	return GLU_TESS_VERTEX;
}

long CWaiteGLCtrl::gluTessEnd() 
{
	return GLU_TESS_END;
}

long CWaiteGLCtrl::gluTessError() 
{
	return GLU_TESS_ERROR;
}

long CWaiteGLCtrl::gluTessEdgeFlag() 
{
	return GLU_TESS_EDGE_FLAG;
}

long CWaiteGLCtrl::gluTessCombine() 
{
	return GLU_TESS_COMBINE;
}

long CWaiteGLCtrl::gluTessBeginData() 
	{
	return GLU_TESS_BEGIN_DATA;
	}

long CWaiteGLCtrl::gluTessVertexData() 
	{
	return GLU_TESS_VERTEX_DATA;
	}

long CWaiteGLCtrl::gluTessEndData() 
	{
	return GLU_TESS_END_DATA;
	}

long CWaiteGLCtrl::gluTessErrorData() 
	{
	return GLU_TESS_ERROR_DATA;
	}

long CWaiteGLCtrl::gluTessEdgeFlagData() 
	{
	return GLU_TESS_EDGE_FLAG_DATA;
	}

long CWaiteGLCtrl::gluTessCombineData() 
	{
	return GLU_TESS_COMBINE_DATA;
	}

long CWaiteGLCtrl::gluTessError1() 
{
	return GLU_TESS_ERROR1;
}

long CWaiteGLCtrl::gluTessError2() 
{
	return GLU_TESS_ERROR2;
}

long CWaiteGLCtrl::gluTessError3() 
{
	return GLU_TESS_ERROR3;
}

long CWaiteGLCtrl::gluTessError4() 
{
	return GLU_TESS_ERROR4;
}

long CWaiteGLCtrl::gluTessError5() 
{
	return GLU_TESS_ERROR5;
}

long CWaiteGLCtrl::gluTessError6() 
{
	return GLU_TESS_ERROR6;
}

long CWaiteGLCtrl::gluTessError7() 
{
	return GLU_TESS_ERROR7;
}

long CWaiteGLCtrl::gluTessError8() 
{
	return GLU_TESS_ERROR8;
}

long CWaiteGLCtrl::gluTessMissingBeginPolygon() 
{
	return GLU_TESS_MISSING_BEGIN_POLYGON;
}

long CWaiteGLCtrl::gluTessMissingBeginContour() 
{
	return GLU_TESS_MISSING_BEGIN_CONTOUR;
}

long CWaiteGLCtrl::gluTessMissingEndPolygon() 
{
	return GLU_TESS_MISSING_END_POLYGON;
}

long CWaiteGLCtrl::gluTessMissingEndContour() 
{
	return GLU_TESS_MISSING_END_CONTOUR;
}

long CWaiteGLCtrl::gluTessCoordTooLarge() 
{
	return GLU_TESS_COORD_TOO_LARGE;
}

long CWaiteGLCtrl::gluTessNeedCombineCallback() 
{
	return GLU_TESS_NEED_COMBINE_CALLBACK;
}

long CWaiteGLCtrl::gluAutoLoadMatrix() 
{
	return GLU_AUTO_LOAD_MATRIX;
}

long CWaiteGLCtrl::gluCulling() 
{
	return GLU_CULLING;
}

long CWaiteGLCtrl::gluSamplingTolerance() 
{
	return GLU_SAMPLING_TOLERANCE;
}

long CWaiteGLCtrl::gluDisplayMode() 
{
	return GLU_DISPLAY_MODE;
}

long CWaiteGLCtrl::gluParametricTolerance() 
{
	return GLU_PARAMETRIC_TOLERANCE;
}

long CWaiteGLCtrl::gluSamplingMethod() 
{
	return GLU_SAMPLING_METHOD;
}

long CWaiteGLCtrl::gluUStep() 
{
	return GLU_U_STEP;
}

long CWaiteGLCtrl::gluVStep() 
{
	return GLU_V_STEP;
}

long CWaiteGLCtrl::gluPathLength() 
{
	return GLU_PATH_LENGTH;
}

long CWaiteGLCtrl::gluParametricError() 
{
	return GLU_PARAMETRIC_ERROR;
}

long CWaiteGLCtrl::gluDomainDistance() 
{
	return GLU_DOMAIN_DISTANCE;
}

long CWaiteGLCtrl::gluMap1Trim2() 
{
	return GLU_MAP1_TRIM_2;
}

long CWaiteGLCtrl::gluMap1Trim3() 
{
	return GLU_MAP1_TRIM_3;
}

long CWaiteGLCtrl::gluOutlinePolygon() 
{
	return GLU_OUTLINE_POLYGON;
}

long CWaiteGLCtrl::gluOutlinePatch() 
	{
	return GLU_OUTLINE_PATCH;
	}

long CWaiteGLCtrl::gluNurbsError1() 
	{
	return GLU_NURBS_ERROR1;
	}

long CWaiteGLCtrl::gluNurbsError2() 
	{
	return GLU_NURBS_ERROR2;
	}

long CWaiteGLCtrl::gluNurbsError3() 
	{
	return GLU_NURBS_ERROR4;
	}

long CWaiteGLCtrl::gluNurbsError4() 
	{
	return GLU_NURBS_ERROR4;
	}

long CWaiteGLCtrl::gluNurbsError5() 
	{
	return GLU_NURBS_ERROR5;
	}

long CWaiteGLCtrl::gluNurbsError6() 
	{
	return GLU_NURBS_ERROR6;
	}

long CWaiteGLCtrl::gluNurbsError7() 
	{
	return GLU_NURBS_ERROR7;
	}

long CWaiteGLCtrl::gluNurbsError8() 
	{
	return GLU_NURBS_ERROR8;
	}

long CWaiteGLCtrl::gluNurbsError9() 
	{
	return GLU_NURBS_ERROR9;
	}

long CWaiteGLCtrl::gluNurbsError10() 
	{
	return GLU_NURBS_ERROR10;
	}

long CWaiteGLCtrl::gluNurbsError11() 
	{
	return GLU_NURBS_ERROR11;
	}

long CWaiteGLCtrl::gluNurbsError12() 
	{
	return GLU_NURBS_ERROR12;
	}

long CWaiteGLCtrl::gluNurbsError13() 
	{
	return GLU_NURBS_ERROR13;
	}

long CWaiteGLCtrl::gluNurbsError14() 
	{
	return GLU_NURBS_ERROR14;
	}

long CWaiteGLCtrl::gluNurbsError15() 
	{
	return GLU_NURBS_ERROR15;
	}

long CWaiteGLCtrl::gluNurbsError16() 
	{
	return GLU_NURBS_ERROR16;
	}

long CWaiteGLCtrl::gluNurbsError17() 
	{
	return GLU_NURBS_ERROR17;
	}

long CWaiteGLCtrl::gluNurbsError18() 
	{
	return GLU_NURBS_ERROR18;
	}

long CWaiteGLCtrl::gluNurbsError19() 
	{
	return GLU_NURBS_ERROR19;
	}

long CWaiteGLCtrl::gluNurbsError20() 
	{
	return GLU_NURBS_ERROR20;
	}

long CWaiteGLCtrl::gluNurbsError21() 
	{
	return GLU_NURBS_ERROR21;
	}

long CWaiteGLCtrl::gluNurbsError22() 
	{
	return GLU_NURBS_ERROR22;
	}

long CWaiteGLCtrl::gluNurbsError23() 
	{
	return GLU_NURBS_ERROR23;
	}

long CWaiteGLCtrl::gluNurbsError24() 
	{
	return GLU_NURBS_ERROR24;
	}

long CWaiteGLCtrl::gluNurbsError25() 
	{
	return GLU_NURBS_ERROR25;
	}

long CWaiteGLCtrl::gluNurbsError26() 
	{
	return GLU_NURBS_ERROR26;
	}

long CWaiteGLCtrl::gluNurbsError27() 
	{
	return GLU_NURBS_ERROR27;
	}

long CWaiteGLCtrl::gluNurbsError28() 
	{
	return GLU_NURBS_ERROR28;
	}

long CWaiteGLCtrl::gluNurbsError30() 
	{
	return GLU_NURBS_ERROR30;
	}

long CWaiteGLCtrl::gluNurbsError31() 
	{
	return GLU_NURBS_ERROR31;
	}

long CWaiteGLCtrl::gluNurbsError32() 
	{
	return GLU_NURBS_ERROR32;
	}

long CWaiteGLCtrl::gluNurbsError33() 
	{
	return GLU_NURBS_ERROR33;
	}

long CWaiteGLCtrl::gluNurbsError34() 
	{
	return GLU_NURBS_ERROR34;
	}

long CWaiteGLCtrl::gluNurbsError35() 
	{
	return GLU_NURBS_ERROR35;
	}

long CWaiteGLCtrl::gluNurbsError36() 
	{
	return GLU_NURBS_ERROR36;
	}

long CWaiteGLCtrl::gluNurbsError37() 
	{
	return GLU_NURBS_ERROR37;
	}
