// WaiteGLCtl.cpp : Implementation of the CWaiteGLCtrl OLE control class.

#include "stdafx.h"
#include "WaiteGL.h"
#include "WaiteGLCtl.h"
#include "WaiteGLPpg.h"

#include <math.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


IMPLEMENT_DYNCREATE(CWaiteGLCtrl, COleControl)


/////////////////////////////////////////////////////////////////////////////
// Message map

BEGIN_MESSAGE_MAP(CWaiteGLCtrl, COleControl)
	//{{AFX_MSG_MAP(CWaiteGLCtrl)
	ON_WM_CREATE()
	ON_WM_DESTROY()
	ON_WM_PALETTECHANGED()
	ON_WM_QUERYNEWPALETTE()
	//}}AFX_MSG_MAP
	ON_OLEVERB(AFX_IDS_VERB_PROPERTIES, OnProperties)
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// Dispatch map

BEGIN_DISPATCH_MAP(CWaiteGLCtrl, COleControl)
	//{{AFX_DISPATCH_MAP(CWaiteGLCtrl)
	DISP_FUNCTION(CWaiteGLCtrl, "Flush", Flush, VT_EMPTY, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "ClearColor", ClearColor, VT_EMPTY, VTS_R4 VTS_R4 VTS_R4 VTS_R4)
	DISP_FUNCTION(CWaiteGLCtrl, "Clear", Clear, VT_EMPTY, VTS_I4)
	DISP_FUNCTION(CWaiteGLCtrl, "glColorBufferBit", glColorBufferBit, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "SwapBuffers", SwapBuffers, VT_BOOL, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "MakeCurrent", MakeCurrent, VT_BOOL, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "MakeNotCurrent", MakeNotCurrent, VT_BOOL, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "Color", Color, VT_EMPTY, VTS_I2 VTS_I2 VTS_I2 VTS_I2)
	DISP_FUNCTION(CWaiteGLCtrl, "Rect", Rect, VT_EMPTY, VTS_R4 VTS_R4 VTS_R4 VTS_R4)
	DISP_FUNCTION(CWaiteGLCtrl, "Ortho", Ortho, VT_EMPTY, VTS_R4 VTS_R4 VTS_R4 VTS_R4 VTS_R4 VTS_R4)
	DISP_FUNCTION(CWaiteGLCtrl, "auxSolidTeapot", auxSolidTeapot, VT_EMPTY, VTS_R8)
	DISP_FUNCTION(CWaiteGLCtrl, "auxWireTeapot", auxWireTeapot, VT_EMPTY, VTS_R8)
	DISP_FUNCTION(CWaiteGLCtrl, "Rotate", Rotate, VT_EMPTY, VTS_R4 VTS_R4 VTS_R4 VTS_R4)
	DISP_FUNCTION(CWaiteGLCtrl, "LoadIdentity", LoadIdentity, VT_EMPTY, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "gluPerspective", gluPerspective, VT_EMPTY, VTS_R8 VTS_R8 VTS_R8 VTS_R8)
	DISP_FUNCTION(CWaiteGLCtrl, "glAccum", glAccum, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "auxSolidSphere", auxSolidSphere, VT_EMPTY, VTS_R8)
	DISP_FUNCTION(CWaiteGLCtrl, "auxWireSphere", auxWireSphere, VT_EMPTY, VTS_R8)
	DISP_FUNCTION(CWaiteGLCtrl, "auxWireCube", auxWireCube, VT_EMPTY, VTS_R8)
	DISP_FUNCTION(CWaiteGLCtrl, "auxSolidCube", auxSolidCube, VT_EMPTY, VTS_R8)
	DISP_FUNCTION(CWaiteGLCtrl, "auxWireBox", auxWireBox, VT_EMPTY, VTS_R8 VTS_R8 VTS_R8)
	DISP_FUNCTION(CWaiteGLCtrl, "auxSolidBox", auxSolidBox, VT_EMPTY, VTS_R8 VTS_R8 VTS_R8)
	DISP_FUNCTION(CWaiteGLCtrl, "auxSolidTorus", auxSolidTorus, VT_EMPTY, VTS_R8 VTS_R8)
	DISP_FUNCTION(CWaiteGLCtrl, "auxWireTorus", auxWireTorus, VT_EMPTY, VTS_R8 VTS_R8)
	DISP_FUNCTION(CWaiteGLCtrl, "auxWireCylinder", auxWireCylinder, VT_EMPTY, VTS_R8 VTS_R8)
	DISP_FUNCTION(CWaiteGLCtrl, "auxSolidCylinder", auxSolidCylinder, VT_EMPTY, VTS_R8 VTS_R8)
	DISP_FUNCTION(CWaiteGLCtrl, "auxWireIcosahedron", auxWireIcosahedron, VT_EMPTY, VTS_R8)
	DISP_FUNCTION(CWaiteGLCtrl, "auxSolidIcosahedron", auxSolidIcosahedron, VT_EMPTY, VTS_R8)
	DISP_FUNCTION(CWaiteGLCtrl, "auxWireOctahedron", auxWireOctahedron, VT_EMPTY, VTS_R8)
	DISP_FUNCTION(CWaiteGLCtrl, "auxSolidOctahedron", auxSolidOctahedron, VT_EMPTY, VTS_R8)
	DISP_FUNCTION(CWaiteGLCtrl, "auxWireDodecahedron", auxWireDodecahedron, VT_EMPTY, VTS_R8)
	DISP_FUNCTION(CWaiteGLCtrl, "auxSolidDodecahedron", auxSolidDodecahedron, VT_EMPTY, VTS_R8)
	DISP_FUNCTION(CWaiteGLCtrl, "auxWireCone", auxWireCone, VT_EMPTY, VTS_R8 VTS_R8)
	DISP_FUNCTION(CWaiteGLCtrl, "auxSolidCone", auxSolidCone, VT_EMPTY, VTS_R8 VTS_R8)
	DISP_FUNCTION(CWaiteGLCtrl, "Viewport", Viewport, VT_EMPTY, VTS_I4 VTS_I4 VTS_I4 VTS_I4)
	DISP_FUNCTION(CWaiteGLCtrl, "wglGetRC", wglGetRC, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "wglGetDC", wglGetDC, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "wglUseFontBitmaps", wglUseFontBitmaps, VT_BOOL, VTS_I4 VTS_I4 VTS_I4 VTS_I4)
	DISP_FUNCTION(CWaiteGLCtrl, "Begin", Begin, VT_EMPTY, VTS_I4)
	DISP_FUNCTION(CWaiteGLCtrl, "End", End, VT_EMPTY, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "Enable", Enable, VT_EMPTY, VTS_I4)
	DISP_FUNCTION(CWaiteGLCtrl, "Disable", Disable, VT_EMPTY, VTS_I4)
	DISP_FUNCTION(CWaiteGLCtrl, "glLoad", glLoad, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glReturn", glReturn, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glMult", glMult, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glAdd", glAdd, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glNever", glNever, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glLess", glLess, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glEqual", glEqual, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glLequal", glLequal, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glGreater", glGreater, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glNotequal", glNotequal, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glGequal", glGequal, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glAlways", glAlways, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glPoints", glPoints, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glLines", glLines, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glLineLoop", glLineLoop, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glLineStrip", glLineStrip, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glTriangles", glTriangles, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glTriangleStrip", glTriangleStrip, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glTriangleFan", glTriangleFan, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glQuads", glQuads, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glQuadStrip", glQuadStrip, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glPolygon", glPolygon, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "Normal", Normal, VT_EMPTY, VTS_R4 VTS_R4 VTS_R4)
	DISP_FUNCTION(CWaiteGLCtrl, "glCurrentBit", glCurrentBit, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glPointbit", glPointbit, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glLineBit", glLineBit, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glPolygonBit", glPolygonBit, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glPolygonStippleBit", glPolygonStippleBit, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glPixelModeBit", glPixelModeBit, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glLightingBit", glLightingBit, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glFogBit", glFogBit, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glDepthBufferBit", glDepthBufferBit, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glAccumBufferBit", glAccumBufferBit, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glStencilBufferbit", glStencilBufferbit, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glViewportBit", glViewportBit, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glTransformBit", glTransformBit, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glEnableBit", glEnableBit, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glHintBit", glHintBit, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glEvalBit", glEvalBit, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glListBit", glListBit, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glTextureBit", glTextureBit, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glScissorBit", glScissorBit, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glAllAttribBits", glAllAttribBits, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glNoError", glNoError, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glInvalidEnum", glInvalidEnum, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glInvalidValue", glInvalidValue, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glInvalidOperation", glInvalidOperation, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glStackOverflow", glStackOverflow, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glStackUnderflow", glStackUnderflow, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glOutOfMemory", glOutOfMemory, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glDontCare", glDontCare, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glFastest", glFastest, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glNicest", glNicest, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glLight0", glLight0, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glLight1", glLight1, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glLight2", glLight2, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glLight3", glLight3, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glLight4", glLight4, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glLight5", glLight5, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glLight6", glLight6, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glLight7", glLight7, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glAmbient", glAmbient, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glDiffuse", glDiffuse, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glSpecular", glSpecular, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glPosition", glPosition, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glSpotDirection", glSpotDirection, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glSpotExponent", glSpotExponent, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glSpotCutoff", glSpotCutoff, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glConstantAttenuation", glConstantAttenuation, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glLinearAttenuation", glLinearAttenuation, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glQuadraticAttenuation", glQuadraticAttenuation, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glEmission", glEmission, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glShininess", glShininess, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glAmbientAndDiffuse", glAmbientAndDiffuse, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glColorIndexes", glColorIndexes, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glModelview", glModelview, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glProjection", glProjection, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glTexture", glTexture, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "EndList", EndList, VT_EMPTY, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "CallList", CallList, VT_EMPTY, VTS_I4)
	DISP_FUNCTION(CWaiteGLCtrl, "NewList", NewList, VT_EMPTY, VTS_I4 VTS_I4)
	DISP_FUNCTION(CWaiteGLCtrl, "DeleteLists", DeleteLists, VT_EMPTY, VTS_I4 VTS_I4)
	DISP_FUNCTION(CWaiteGLCtrl, "glColor", glColor, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glDepth", glDepth, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glStencil", glStencil, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glFlat", glFlat, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glSmooth", glSmooth, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glPoint", glPoint, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glLine", glLine, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glFill", glFill, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glCw", glCw, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glCcw", glCcw, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glCurrentColor", glCurrentColor, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glCurrentIndex", glCurrentIndex, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glCurrentNormal", glCurrentNormal, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glCurrentTextureCoords", glCurrentTextureCoords, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glCurrentRasterColor", glCurrentRasterColor, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glCurrentRasterIndex", glCurrentRasterIndex, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glCurrentRasterTextureCoords", glCurrentRasterTextureCoords, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glCurrentRasterPosition", glCurrentRasterPosition, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glCurrentRasterPositionValid", glCurrentRasterPositionValid, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glCurrentRasterDistance", glCurrentRasterDistance, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glPointSmooth", glPointSmooth, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glPointSize", glPointSize, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glPointSizeRange", glPointSizeRange, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glPointSizeGranularity", glPointSizeGranularity, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glLineSmooth", glLineSmooth, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glLineWidth", glLineWidth, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glLineWidthRange", glLineWidthRange, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glLineWidthGranularity", glLineWidthGranularity, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glLineStipple", glLineStipple, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glLineStipplePattern", glLineStipplePattern, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glLineStippleRepeat", glLineStippleRepeat, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glListMode", glListMode, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glMaxListNesting", glMaxListNesting, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glListBase", glListBase, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glListIndex", glListIndex, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glPolygonMode", glPolygonMode, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glPolygonSmooth", glPolygonSmooth, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glPolygonStipple", glPolygonStipple, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glEdgeFlag", glEdgeFlag, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glCullFace", glCullFace, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glCullFaceMode", glCullFaceMode, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glFrontFace", glFrontFace, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glLighting", glLighting, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glLightModelLocalViewer", glLightModelLocalViewer, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glLightModelTwoSide", glLightModelTwoSide, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glLightModelAmbient", glLightModelAmbient, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glShadeModel", glShadeModel, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glColorMaterialFace", glColorMaterialFace, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glColorMaterialParameter", glColorMaterialParameter, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glColorMaterial", glColorMaterial, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glFog", glFog, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glFogIndex", glFogIndex, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glFogDensity", glFogDensity, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glFogStart", glFogStart, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glFogEnd", glFogEnd, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glFogMode", glFogMode, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glFogColor", glFogColor, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glDepthRange", glDepthRange, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glDepthTest", glDepthTest, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glDepthWritemask", glDepthWritemask, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glDepthClearValue", glDepthClearValue, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glDepthFunc", glDepthFunc, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glAccumClearValue", glAccumClearValue, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glStencilTest", glStencilTest, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glStencilClearValue", glStencilClearValue, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glStencilFunc", glStencilFunc, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glStencilValueMask", glStencilValueMask, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glStencilFail", glStencilFail, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glStencilPassDepthFail", glStencilPassDepthFail, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glStencilPassDepthPass", glStencilPassDepthPass, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glStencilRef", glStencilRef, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glStencilWritemask", glStencilWritemask, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glMatrixMode", glMatrixMode, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glNormalize", glNormalize, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glViewport", glViewport, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glModelviewStackDepth", glModelviewStackDepth, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glProjectionStackDepth", glProjectionStackDepth, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glTextureStackDepth", glTextureStackDepth, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glModelviewMatrix", glModelviewMatrix, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glProjectionMatrix", glProjectionMatrix, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glTextureMatrix", glTextureMatrix, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glAttribStackDepth", glAttribStackDepth, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glCompile", glCompile, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glCompileAndExecute", glCompileAndExecute, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glBitmap", glBitmap, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glRender", glRender, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glFeedback", glFeedback, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glSelect", glSelect, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glVendor", glVendor, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glRenderer", glRenderer, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glVersion", glVersion, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glExtensions", glExtensions, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glAlphaTest", glAlphaTest, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glAlphaTestFunc", glAlphaTestFunc, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glAlphaTestRef", glAlphaTestRef, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glDither", glDither, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "FrontFace", FrontFace, VT_EMPTY, VTS_I4)
	DISP_FUNCTION(CWaiteGLCtrl, "Start", Start, VT_EMPTY, VTS_I4)
	DISP_FUNCTION(CWaiteGLCtrl, "Stop", Stop, VT_EMPTY, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "PushMatrix", PushMatrix, VT_EMPTY, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "PopMatrix", PopMatrix, VT_EMPTY, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "Translate", Translate, VT_EMPTY, VTS_R4 VTS_R4 VTS_R4)
	DISP_FUNCTION(CWaiteGLCtrl, "Scale", Scale, VT_EMPTY, VTS_R4 VTS_R4 VTS_R4)
	DISP_FUNCTION(CWaiteGLCtrl, "IsList", IsList, VT_BOOL, VTS_I4)
	DISP_FUNCTION(CWaiteGLCtrl, "ListBase", ListBase, VT_EMPTY, VTS_I4)
	DISP_FUNCTION(CWaiteGLCtrl, "LineStipple", LineStipple, VT_EMPTY, VTS_I4 VTS_I2)
	DISP_FUNCTION(CWaiteGLCtrl, "LineWidth", LineWidth, VT_EMPTY, VTS_R4)
	DISP_FUNCTION(CWaiteGLCtrl, "PointSize", PointSize, VT_EMPTY, VTS_R4)
	DISP_FUNCTION(CWaiteGLCtrl, "Vertex2", Vertex2, VT_EMPTY, VTS_R4 VTS_R4)
	DISP_FUNCTION(CWaiteGLCtrl, "Vertex3", Vertex3, VT_EMPTY, VTS_R4 VTS_R4 VTS_R4)
	DISP_FUNCTION(CWaiteGLCtrl, "Vertex4", Vertex4, VT_EMPTY, VTS_R4 VTS_R4 VTS_R4 VTS_R4)
	DISP_FUNCTION(CWaiteGLCtrl, "glClamp", glClamp, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glRepeat", glRepeat, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "PolygonStipple", PolygonStipple, VT_EMPTY, VTS_PVARIANT)
	DISP_FUNCTION(CWaiteGLCtrl, "PolygonMode", PolygonMode, VT_EMPTY, VTS_I4 VTS_I4)
	DISP_FUNCTION(CWaiteGLCtrl, "EdgeFlag", EdgeFlag, VT_EMPTY, VTS_BOOL)
	DISP_FUNCTION(CWaiteGLCtrl, "GetPolygonStipple", GetPolygonStipple, VT_EMPTY, VTS_PVARIANT)
	DISP_FUNCTION(CWaiteGLCtrl, "Frustum", Frustum, VT_EMPTY, VTS_R4 VTS_R4 VTS_R4 VTS_R4 VTS_R4 VTS_R4)
	DISP_FUNCTION(CWaiteGLCtrl, "gluLookAt", gluLookAt, VT_EMPTY, VTS_R4 VTS_R4 VTS_R4 VTS_R4 VTS_R4 VTS_R4 VTS_R4 VTS_R4 VTS_R4)
	DISP_FUNCTION(CWaiteGLCtrl, "gluOrtho2D", gluOrtho2D, VT_EMPTY, VTS_R4 VTS_R4 VTS_R4 VTS_R4)
	DISP_FUNCTION(CWaiteGLCtrl, "Hint", Hint, VT_EMPTY, VTS_I4 VTS_I4)
	DISP_FUNCTION(CWaiteGLCtrl, "ShadeModel", ShadeModel, VT_EMPTY, VTS_I4)
	DISP_FUNCTION(CWaiteGLCtrl, "CullFace", CullFace, VT_EMPTY, VTS_I4)
	DISP_FUNCTION(CWaiteGLCtrl, "glNearest", glNearest, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glLinear", glLinear, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glTextureMagFilter", glTextureMagFilter, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glTextureMinFilter", glTextureMinFilter, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glTextureWrapS", glTextureWrapS, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glTextureWrapT", glTextureWrapT, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glNearestMipmapNearest", glNearestMipmapNearest, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glLinearMipmapNearest", glLinearMipmapNearest, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glNearestMipmapLinear", glNearestMipmapLinear, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glLinearMipmapLinear", glLinearMipmapLinear, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "gluErrorString", gluErrorString, VT_BSTR, VTS_I4)
	DISP_FUNCTION(CWaiteGLCtrl, "GetString", GetString, VT_BSTR, VTS_I4)
	DISP_FUNCTION(CWaiteGLCtrl, "GetError", GetError, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "gluGetString", gluGetString, VT_BSTR, VTS_I4)
	DISP_FUNCTION(CWaiteGLCtrl, "glKeep", glKeep, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glReplace", glReplace, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glIncr", glIncr, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glDecr", glDecr, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glS", glS, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glT", glT, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glR", glR, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glQ", glQ, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glModulate", glModulate, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glDecal", glDecal, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glTextureEnvMode", glTextureEnvMode, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glTextureEnvColor", glTextureEnvColor, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glTextureEnv", glTextureEnv, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glEyeLinear", glEyeLinear, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glObjectLinear", glObjectLinear, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glSphereMap", glSphereMap, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glTextureGenMode", glTextureGenMode, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glObjectPlane", glObjectPlane, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glEyePlane", glEyePlane, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "gluVersion", gluVersion, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "gluExtensions", gluExtensions, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glZero", glZero, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glOne", glOne, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glSrcColor", glSrcColor, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glOneMinusSrcColor", glOneMinusSrcColor, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glSrcAlpha", glSrcAlpha, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glOneMinusSrcAlpha", glOneMinusSrcAlpha, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glDstAlpha", glDstAlpha, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glOneMinusDstAlpha", glOneMinusDstAlpha, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glDstColor", glDstColor, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glOneMinusDstColor", glOneMinusDstColor, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glSrcAlphaSaturate", glSrcAlphaSaturate, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glClipPlane0", glClipPlane0, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glClipPlane1", glClipPlane1, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glClipPlane2", glClipPlane2, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glClipPlane3", glClipPlane3, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glClipPlane4", glClipPlane4, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glClipPlane5", glClipPlane5, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glNone", glNone, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glFrontLeft", glFrontLeft, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glFrontRight", glFrontRight, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glBackLeft", glBackLeft, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glBackRight", glBackRight, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glFront", glFront, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glBack", glBack, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glLeft", glLeft, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glRight", glRight, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glFrontAndBack", glFrontAndBack, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glAux0", glAux0, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glAux1", glAux1, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glAux2", glAux2, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glAux3", glAux3, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "gl2d", gl2d, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "gl3d", gl3d, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "gl3dColor", gl3dColor, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "gl3dColorTexture", gl3dColorTexture, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "gl4dColorTexture", gl4dColorTexture, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glPassThroughToken", glPassThroughToken, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glPointToken", glPointToken, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glLineToken", glLineToken, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glPolygonToken", glPolygonToken, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glBitmapToken", glBitmapToken, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glDrawPixelToken", glDrawPixelToken, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glCopyPixelToken", glCopyPixelToken, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glLineResetToken", glLineResetToken, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glExp", glExp, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glExp2", glExp2, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glCoeff", glCoeff, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glOrder", glOrder, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glDomain", glDomain, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glBlendDst", glBlendDst, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glBlendSrc", glBlendSrc, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glBlend", glBlend, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glLogicOpMode", glLogicOpMode, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glLogicOp", glLogicOp, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glAuxBuffers", glAuxBuffers, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glDrawBuffer", glDrawBuffer, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glReadBuffer", glReadBuffer, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glScissorBox", glScissorBox, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glScissorTest", glScissorTest, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glIndexClearValue", glIndexClearValue, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glIndexWritemask", glIndexWritemask, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glColorClearValue", glColorClearValue, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glColorWritemask", glColorWritemask, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glIndexMode", glIndexMode, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glRgbaMode", glRgbaMode, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "ColorMaterial", ColorMaterial, VT_EMPTY, VTS_I4 VTS_I4)
	DISP_FUNCTION(CWaiteGLCtrl, "glStereo", glStereo, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glRenderMode", glRenderMode, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glPerspectiveCorrectionHint", glPerspectiveCorrectionHint, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glPointSmoothHint", glPointSmoothHint, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glLineSmoothHint", glLineSmoothHint, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glPolygonSmoothHint", glPolygonSmoothHint, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glFogHint", glFogHint, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glTextureGenS", glTextureGenS, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glTextureGenT", glTextureGenT, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glTextureGenR", glTextureGenR, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glTextureGenQ", glTextureGenQ, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glPixelMapIToI", glPixelMapIToI, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glPixelMapSToS", glPixelMapSToS, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glPixelMapIToR", glPixelMapIToR, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glPixelMapIToG", glPixelMapIToG, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glPixelMapIToB", glPixelMapIToB, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glPixelMapIToA", glPixelMapIToA, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glPixelMapRToR", glPixelMapRToR, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glPixelMapGToG", glPixelMapGToG, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glPixelMapBToB", glPixelMapBToB, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glPixelMapAToA", glPixelMapAToA, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glPixelMapIToISize", glPixelMapIToISize, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glPixelMapSToSSize", glPixelMapSToSSize, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glPixelMapIToRSize", glPixelMapIToRSize, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glPixelMapIToGSize", glPixelMapIToGSize, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glPixelMapIToBSize", glPixelMapIToBSize, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glPixelMapIToASize", glPixelMapIToASize, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glPixelMapRToRSize", glPixelMapRToRSize, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glPixelMapGToGSize", glPixelMapGToGSize, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glPixelMapBToBSize", glPixelMapBToBSize, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glPixelMapAToASize", glPixelMapAToASize, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glUnpackSwapBytes", glUnpackSwapBytes, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glUnpackLsbFirst", glUnpackLsbFirst, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glUnpackRowLength", glUnpackRowLength, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glUnpackSkipRows", glUnpackSkipRows, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glUnpackSkipPixels", glUnpackSkipPixels, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glUnpackAlignment", glUnpackAlignment, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glPackSwapBytes", glPackSwapBytes, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glPackLsbFirst", glPackLsbFirst, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glPackRowLength", glPackRowLength, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glPackSkipRows", glPackSkipRows, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glPackSkipPixels", glPackSkipPixels, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glPackAlignment", glPackAlignment, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glMapColor", glMapColor, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glMapStencil", glMapStencil, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glIndexShift", glIndexShift, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glIndexOffset", glIndexOffset, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glRedScale", glRedScale, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glRedBias", glRedBias, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glZoomX", glZoomX, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glZoomY", glZoomY, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glGreenScale", glGreenScale, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glGreenBias", glGreenBias, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glBlueScale", glBlueScale, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glBlueBias", glBlueBias, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glAlphaScale", glAlphaScale, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glAlphaBias", glAlphaBias, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glDepthScale", glDepthScale, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glDepthBias", glDepthBias, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glMaxEvalOrder", glMaxEvalOrder, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glMaxLights", glMaxLights, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glMaxClipPlanes", glMaxClipPlanes, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glMaxTextureSize", glMaxTextureSize, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glMaxPixelMapTable", glMaxPixelMapTable, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glMaxAttribStackDepth", glMaxAttribStackDepth, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glMaxModelviewStackDepth", glMaxModelviewStackDepth, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glMaxNameStackDepth", glMaxNameStackDepth, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glMaxProjectionStackDepth", glMaxProjectionStackDepth, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glMaxTextureStackDepth", glMaxTextureStackDepth, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glMaxViewportDims", glMaxViewportDims, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glSubpixelBits", glSubpixelBits, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glIndexBits", glIndexBits, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glRedBits", glRedBits, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glGreenBits", glGreenBits, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glBlueBits", glBlueBits, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glAlphaBits", glAlphaBits, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glDepthBits", glDepthBits, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glStencilBits", glStencilBits, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glAccumRedBits", glAccumRedBits, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glAccumGreenBits", glAccumGreenBits, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glAccumAlphaBits", glAccumAlphaBits, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glNameStackDepth", glNameStackDepth, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glAutoNormal", glAutoNormal, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glMap1Color4", glMap1Color4, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glMap1Index", glMap1Index, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glMap1Normal", glMap1Normal, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glMap1TextureCoord1", glMap1TextureCoord1, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glMap1TextureCoord2", glMap1TextureCoord2, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glMap1TextureCoord3", glMap1TextureCoord3, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glMap1TextureCoord4", glMap1TextureCoord4, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glMap1Vertex3", glMap1Vertex3, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glMap1Vertex4", glMap1Vertex4, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glMap2Color4", glMap2Color4, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glMap2Index", glMap2Index, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glMap2Normal", glMap2Normal, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glMap2TextureCoord1", glMap2TextureCoord1, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glMap2TextureCoord2", glMap2TextureCoord2, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glMap2TextureCoord3", glMap2TextureCoord3, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glMap2TextureCoord4", glMap2TextureCoord4, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glMap2Vertex3", glMap2Vertex3, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glMap2Vertex4", glMap2Vertex4, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glMap1GridDomain", glMap1GridDomain, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glMap1GridSegments", glMap1GridSegments, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glMap2GridDomain", glMap2GridDomain, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glMap2GridSegments", glMap2GridSegments, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glTexture1d", glTexture1d, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glTexture2d", glTexture2d, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glTextureWidth", glTextureWidth, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glTextureHeight", glTextureHeight, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glTextureComponents", glTextureComponents, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glTextureBorderColor", glTextureBorderColor, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glTextureBorder", glTextureBorder, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glByte", glByte, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glUnsignedByte", glUnsignedByte, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glShort", glShort, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glUnsignedShort", glUnsignedShort, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glInt", glInt, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glUnsignedInt", glUnsignedInt, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glFloat", glFloat, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "gl2Bytes", gl2Bytes, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "gl3Bytes", gl3Bytes, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "gl4Bytes", gl4Bytes, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glDoubleExt", glDoubleExt, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glClear", glClear, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glAnd", glAnd, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glAndReverse", glAndReverse, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glCopy", glCopy, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glAndInverted", glAndInverted, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glNoop", glNoop, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glXor", glXor, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glOr", glOr, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glNor", glNor, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glEquiv", glEquiv, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glInvert", glInvert, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glOrReverse", glOrReverse, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glCopyInverted", glCopyInverted, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glOrInverted", glOrInverted, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glNand", glNand, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glSet", glSet, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glDoublebuffer", glDoublebuffer, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glAccumBlueBits", glAccumBlueBits, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "RenderMode", RenderMode, VT_I4, VTS_I4)
	DISP_FUNCTION(CWaiteGLCtrl, "InitNames", InitNames, VT_EMPTY, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "PopName", PopName, VT_EMPTY, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "AlphaFunc", AlphaFunc, VT_EMPTY, VTS_I4 VTS_R4)
	DISP_FUNCTION(CWaiteGLCtrl, "BlendFunc", BlendFunc, VT_EMPTY, VTS_I4 VTS_I4)
	DISP_FUNCTION(CWaiteGLCtrl, "PushName", PushName, VT_EMPTY, VTS_I4)
	DISP_FUNCTION(CWaiteGLCtrl, "LoadName", LoadName, VT_EMPTY, VTS_I4)
	DISP_FUNCTION(CWaiteGLCtrl, "glColorIndex", glColorIndex, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glStencilIndex", glStencilIndex, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glDepthComponent", glDepthComponent, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glRed", glRed, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glGreen", glGreen, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glBlue", glBlue, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glAlpha", glAlpha, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glRgb", glRgb, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glRgba", glRgba, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glLuminance", glLuminance, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "glLuminanceAlpha", glLuminanceAlpha, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "gluInvalidEnum", gluInvalidEnum, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "gluInvalidValue", gluInvalidValue, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "gluOutOfMemory", gluOutOfMemory, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "gluIncompatibleGlVersion", gluIncompatibleGlVersion, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "gluSmooth", gluSmooth, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "gluFlat", gluFlat, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "gluNone", gluNone, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "gluPoint", gluPoint, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "gluLine", gluLine, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "gluFill", gluFill, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "gluSilhouette", gluSilhouette, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "gluOutside", gluOutside, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "gluInside", gluInside, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "MatrixMode", MatrixMode, VT_EMPTY, VTS_I4)
	DISP_FUNCTION(CWaiteGLCtrl, "gluTessWindingRule", gluTessWindingRule, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "gluTessBoundaryOnly", gluTessBoundaryOnly, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "gluTessTolerance", gluTessTolerance, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "gluTessWindingOdd", gluTessWindingOdd, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "gluTessWindingNonzero", gluTessWindingNonzero, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "gluTessWindingPositive", gluTessWindingPositive, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "gluTessWindingNegative", gluTessWindingNegative, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "gluTessWindingAbsGeqTwo", gluTessWindingAbsGeqTwo, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "gluTessBegin", gluTessBegin, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "gluTessVertex", gluTessVertex, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "gluTessEnd", gluTessEnd, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "gluTessError", gluTessError, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "gluTessEdgeFlag", gluTessEdgeFlag, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "gluTessCombine", gluTessCombine, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "LightModelv", LightModelv, VT_EMPTY, VTS_I4 VTS_R4 VTS_R4 VTS_R4 VTS_R4)
	DISP_FUNCTION(CWaiteGLCtrl, "Light", Light, VT_EMPTY, VTS_I4 VTS_I4 VTS_R4)
	DISP_FUNCTION(CWaiteGLCtrl, "Lightf", Lightf, VT_EMPTY, VTS_I4 VTS_I4 VTS_R4 VTS_R4 VTS_R4 VTS_R4)
	DISP_FUNCTION(CWaiteGLCtrl, "LightModel", LightModel, VT_EMPTY, VTS_I4 VTS_R4)
	DISP_FUNCTION(CWaiteGLCtrl, "Material", Material, VT_EMPTY, VTS_I4 VTS_I4 VTS_R4)
	DISP_FUNCTION(CWaiteGLCtrl, "Materialv", Materialv, VT_EMPTY, VTS_I4 VTS_I4 VTS_R4 VTS_R4 VTS_R4 VTS_R4)
	DISP_FUNCTION(CWaiteGLCtrl, "GetMaterial", GetMaterial, VT_EMPTY, VTS_I4 VTS_I4 VTS_PR4 VTS_PR4 VTS_PR4 VTS_PR4)
	DISP_FUNCTION(CWaiteGLCtrl, "GetLight", GetLight, VT_EMPTY, VTS_I4 VTS_I4 VTS_PR4 VTS_PR4 VTS_PR4 VTS_PR4)
	DISP_FUNCTION(CWaiteGLCtrl, "gluTessBeginData", gluTessBeginData, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "gluTessVertexData", gluTessVertexData, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "gluTessEndData", gluTessEndData, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "gluTessErrorData", gluTessErrorData, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "gluTessEdgeFlagData", gluTessEdgeFlagData, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "gluTessCombineData", gluTessCombineData, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "gluTessError1", gluTessError1, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "gluTessError2", gluTessError2, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "gluTessError3", gluTessError3, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "gluTessError4", gluTessError4, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "gluTessError5", gluTessError5, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "gluTessError6", gluTessError6, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "gluTessError7", gluTessError7, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "gluTessError8", gluTessError8, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "gluTessMissingBeginPolygon", gluTessMissingBeginPolygon, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "gluTessMissingBeginContour", gluTessMissingBeginContour, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "gluTessMissingEndPolygon", gluTessMissingEndPolygon, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "gluTessMissingEndContour", gluTessMissingEndContour, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "gluTessCoordTooLarge", gluTessCoordTooLarge, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "gluTessNeedCombineCallback", gluTessNeedCombineCallback, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "gluAutoLoadMatrix", gluAutoLoadMatrix, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "gluCulling", gluCulling, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "gluSamplingTolerance", gluSamplingTolerance, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "gluDisplayMode", gluDisplayMode, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "gluParametricTolerance", gluParametricTolerance, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "gluSamplingMethod", gluSamplingMethod, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "gluUStep", gluUStep, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "gluVStep", gluVStep, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "gluPathLength", gluPathLength, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "gluParametricError", gluParametricError, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "gluDomainDistance", gluDomainDistance, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "gluMap1Trim3", gluMap1Trim3, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "gluOutlinePolygon", gluOutlinePolygon, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "gluOutlinePatch", gluOutlinePatch, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "GenLists", GenLists, VT_I4, VTS_I4)
	DISP_FUNCTION(CWaiteGLCtrl, "gluMap1Trim2", gluMap1Trim2, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "gluTessMaxCoord", gluTessMaxCoord, VT_R8, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "gluNurbsError1", gluNurbsError1, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "gluNurbsError2", gluNurbsError2, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "gluNurbsError3", gluNurbsError3, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "gluNurbsError4", gluNurbsError4, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "gluNurbsError5", gluNurbsError5, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "gluNurbsError6", gluNurbsError6, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "gluNurbsError7", gluNurbsError7, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "gluNurbsError8", gluNurbsError8, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "gluNurbsError9", gluNurbsError9, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "gluNurbsError10", gluNurbsError10, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "gluNurbsError11", gluNurbsError11, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "gluNurbsError12", gluNurbsError12, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "gluNurbsError13", gluNurbsError13, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "gluNurbsError14", gluNurbsError14, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "gluNurbsError15", gluNurbsError15, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "gluNurbsError16", gluNurbsError16, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "gluNurbsError17", gluNurbsError17, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "gluNurbsError18", gluNurbsError18, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "gluNurbsError19", gluNurbsError19, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "gluNurbsError20", gluNurbsError20, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "gluNurbsError21", gluNurbsError21, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "gluNurbsError22", gluNurbsError22, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "gluNurbsError23", gluNurbsError23, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "gluNurbsError24", gluNurbsError24, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "gluNurbsError25", gluNurbsError25, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "gluNurbsError26", gluNurbsError26, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "gluNurbsError27", gluNurbsError27, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "gluNurbsError28", gluNurbsError28, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "gluNurbsError30", gluNurbsError30, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "gluNurbsError31", gluNurbsError31, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "gluNurbsError32", gluNurbsError32, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "gluNurbsError33", gluNurbsError33, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "gluNurbsError34", gluNurbsError34, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "gluNurbsError35", gluNurbsError35, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "gluNurbsError36", gluNurbsError36, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "gluNurbsError37", gluNurbsError37, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "LoadMatrix", LoadMatrix, VT_EMPTY, VTS_PR4)
	DISP_FUNCTION(CWaiteGLCtrl, "MultMatrix", MultMatrix, VT_EMPTY, VTS_PR4)
	DISP_FUNCTION(CWaiteGLCtrl, "ColorMask", ColorMask, VT_EMPTY, VTS_BOOL VTS_BOOL VTS_BOOL VTS_BOOL)
	DISP_FUNCTION(CWaiteGLCtrl, "Fogv", Fogv, VT_EMPTY, VTS_I4 VTS_R4 VTS_R4 VTS_R4 VTS_R4)
	DISP_FUNCTION(CWaiteGLCtrl, "Fog", Fog, VT_EMPTY, VTS_I4 VTS_R4)
	DISP_FUNCTION(CWaiteGLCtrl, "GLBEGIN", GLBEGIN, VT_EMPTY, VTS_I4)
	DISP_FUNCTION(CWaiteGLCtrl, "GLEND", GLEND, VT_EMPTY, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "CopyPixels", CopyPixels, VT_EMPTY, VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_I4)
	DISP_FUNCTION(CWaiteGLCtrl, "RasterPos2", RasterPos2, VT_EMPTY, VTS_R4 VTS_R4)
	DISP_FUNCTION(CWaiteGLCtrl, "RasterPos3", RasterPos3, VT_EMPTY, VTS_R4 VTS_R4 VTS_R4)
	DISP_FUNCTION(CWaiteGLCtrl, "RasterPos4", RasterPos4, VT_EMPTY, VTS_R4 VTS_R4 VTS_R4 VTS_R4)
	DISP_FUNCTION(CWaiteGLCtrl, "PixelStore", PixelStore, VT_EMPTY, VTS_I4 VTS_R4)
	DISP_FUNCTION(CWaiteGLCtrl, "DrawPixels", DrawPixels, VT_EMPTY, VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_PVARIANT)
	DISP_FUNCTION(CWaiteGLCtrl, "ReadPixels", ReadPixels, VT_EMPTY, VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_PVARIANT)
	DISP_FUNCTION(CWaiteGLCtrl, "Bitmap", Bitmap, VT_EMPTY, VTS_I4 VTS_I4 VTS_R4 VTS_R4 VTS_R4 VTS_R4 VTS_PVARIANT)
	DISP_FUNCTION(CWaiteGLCtrl, "CallLists", CallLists, VT_EMPTY, VTS_I4 VTS_I4 VTS_PVARIANT)
	DISP_FUNCTION(CWaiteGLCtrl, "PixelZoom", PixelZoom, VT_EMPTY, VTS_R4 VTS_R4)
	DISP_FUNCTION(CWaiteGLCtrl, "PixelMap", PixelMap, VT_EMPTY, VTS_I4 VTS_I4 VTS_PVARIANT)
	DISP_FUNCTION(CWaiteGLCtrl, "PixelTransfer", PixelTransfer, VT_EMPTY, VTS_I4 VTS_R4)
	DISP_FUNCTION(CWaiteGLCtrl, "GetPixelMap", GetPixelMap, VT_EMPTY, VTS_I4 VTS_PVARIANT)
	DISP_FUNCTION(CWaiteGLCtrl, "gluBuild2dMipmaps", gluBuild2dMipmaps, VT_EMPTY, VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_PVARIANT)
	DISP_FUNCTION(CWaiteGLCtrl, "gluBuild1DMipmaps", gluBuild1DMipmaps, VT_EMPTY, VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_PVARIANT)
	DISP_FUNCTION(CWaiteGLCtrl, "gluPickMatrix", gluPickMatrix, VT_EMPTY, VTS_R8 VTS_R8 VTS_R8 VTS_R8 VTS_PVARIANT)
	DISP_FUNCTION(CWaiteGLCtrl, "gluScaleImage", gluScaleImage, VT_EMPTY, VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_PVARIANT VTS_I4 VTS_I4 VTS_I4 VTS_PVARIANT)
	DISP_FUNCTION(CWaiteGLCtrl, "SelectBuffer", SelectBuffer, VT_EMPTY, VTS_I4 VTS_PVARIANT)
	DISP_FUNCTION(CWaiteGLCtrl, "FeedbackBuffer", FeedbackBuffer, VT_EMPTY, VTS_I4 VTS_I4 VTS_PVARIANT)
	DISP_FUNCTION(CWaiteGLCtrl, "gluNewQuadric", gluNewQuadric, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "gluDeleteQuadric", gluDeleteQuadric, VT_EMPTY, VTS_I4)
	DISP_FUNCTION(CWaiteGLCtrl, "gluQuadricNormals", gluQuadricNormals, VT_EMPTY, VTS_I4 VTS_I4)
	DISP_FUNCTION(CWaiteGLCtrl, "gluQuadricOrientation", gluQuadricOrientation, VT_EMPTY, VTS_I4 VTS_I4)
	DISP_FUNCTION(CWaiteGLCtrl, "gluQuadricDrawStyle", gluQuadricDrawStyle, VT_EMPTY, VTS_I4 VTS_I4)
	DISP_FUNCTION(CWaiteGLCtrl, "gluCylinder", gluCylinder, VT_EMPTY, VTS_I4 VTS_R8 VTS_R8 VTS_R8 VTS_I4 VTS_I4)
	DISP_FUNCTION(CWaiteGLCtrl, "gluPartialDisk", gluPartialDisk, VT_EMPTY, VTS_I4 VTS_R8 VTS_R8 VTS_I4 VTS_I4 VTS_R8 VTS_R8)
	DISP_FUNCTION(CWaiteGLCtrl, "gluDisk", gluDisk, VT_EMPTY, VTS_I4 VTS_R8 VTS_R8 VTS_I4 VTS_I4)
	DISP_FUNCTION(CWaiteGLCtrl, "gluSphere", gluSphere, VT_EMPTY, VTS_I4 VTS_R8 VTS_I4 VTS_I4)
	DISP_FUNCTION(CWaiteGLCtrl, "gluQuadricTexture", gluQuadricTexture, VT_EMPTY, VTS_I4 VTS_BOOL)
	DISP_FUNCTION(CWaiteGLCtrl, "gluBeginPolygon", gluBeginPolygon, VT_EMPTY, VTS_I4)
	DISP_FUNCTION(CWaiteGLCtrl, "gluEndPolygon", gluEndPolygon, VT_EMPTY, VTS_I4)
	DISP_FUNCTION(CWaiteGLCtrl, "gluNewTess", gluNewTess, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "gluDeleteTess", gluDeleteTess, VT_EMPTY, VTS_I4)
	DISP_FUNCTION(CWaiteGLCtrl, "gluNextCountour", gluNextCountour, VT_EMPTY, VTS_I4 VTS_I4)
	DISP_FUNCTION(CWaiteGLCtrl, "gluTessNormal", gluTessNormal, VT_EMPTY, VTS_I4 VTS_R8 VTS_R8 VTS_R8)
	DISP_FUNCTION(CWaiteGLCtrl, "gluTessProperty", gluTessProperty, VT_EMPTY, VTS_I4 VTS_I4 VTS_R8)
	DISP_FUNCTION(CWaiteGLCtrl, "gluGetTessProperty", gluGetTessProperty, VT_EMPTY, VTS_I4 VTS_I4 VTS_PR8)
	DISP_FUNCTION(CWaiteGLCtrl, "gluTessBeginPolygon", gluTessBeginPolygon, VT_EMPTY, VTS_I4 VTS_PVARIANT)
	DISP_FUNCTION(CWaiteGLCtrl, "gluTessEndPolygon", gluTessEndPolygon, VT_EMPTY, VTS_I4)
	DISP_FUNCTION(CWaiteGLCtrl, "gluTessBeginContour", gluTessBeginContour, VT_EMPTY, VTS_I4)
	DISP_FUNCTION(CWaiteGLCtrl, "gluTessEndContour", gluTessEndContour, VT_EMPTY, VTS_I4)
	DISP_FUNCTION(CWaiteGLCtrl, "IsEnabled", IsEnabled, VT_BOOL, VTS_I4)
	DISP_FUNCTION(CWaiteGLCtrl, "GetFloatv", GetFloatv, VT_EMPTY, VTS_I4 VTS_PR4)
	DISP_FUNCTION(CWaiteGLCtrl, "GetBooleanv", GetBooleanv, VT_EMPTY, VTS_I4 VTS_PBOOL)
	DISP_FUNCTION(CWaiteGLCtrl, "GetDoublev", GetDoublev, VT_EMPTY, VTS_I4 VTS_PR8)
	DISP_FUNCTION(CWaiteGLCtrl, "GetInteger", GetInteger, VT_EMPTY, VTS_I4 VTS_PI4)
	DISP_FUNCTION(CWaiteGLCtrl, "PushAttrib", PushAttrib, VT_EMPTY, VTS_I4)
	DISP_FUNCTION(CWaiteGLCtrl, "PopAttrib", PopAttrib, VT_EMPTY, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "Accum", Accum, VT_EMPTY, VTS_I4 VTS_R4)
	DISP_FUNCTION(CWaiteGLCtrl, "ClearStencil", ClearStencil, VT_EMPTY, VTS_I4)
	DISP_FUNCTION(CWaiteGLCtrl, "ClearDepth", ClearDepth, VT_EMPTY, VTS_R8)
	DISP_FUNCTION(CWaiteGLCtrl, "StencilMask", StencilMask, VT_EMPTY, VTS_I4)
	DISP_FUNCTION(CWaiteGLCtrl, "ClearAccum", ClearAccum, VT_EMPTY, VTS_R4 VTS_R4 VTS_R4 VTS_R4)
	DISP_FUNCTION(CWaiteGLCtrl, "StencilFunc", StencilFunc, VT_EMPTY, VTS_I4 VTS_I4 VTS_I4)
	DISP_FUNCTION(CWaiteGLCtrl, "DepthFunc", DepthFunc, VT_EMPTY, VTS_I4)
	DISP_FUNCTION(CWaiteGLCtrl, "DepthRange", DepthRange, VT_EMPTY, VTS_R8 VTS_R8)
	DISP_FUNCTION(CWaiteGLCtrl, "ReadBuffer", ReadBuffer, VT_EMPTY, VTS_I4)
	DISP_FUNCTION(CWaiteGLCtrl, "ClipPlane", ClipPlane, VT_EMPTY, VTS_I4 VTS_R8 VTS_R8 VTS_R8 VTS_R8)
	DISP_FUNCTION(CWaiteGLCtrl, "Scissor", Scissor, VT_EMPTY, VTS_I4 VTS_I4 VTS_I4 VTS_I4)
	DISP_FUNCTION(CWaiteGLCtrl, "StencilOp", StencilOp, VT_EMPTY, VTS_I4 VTS_I4 VTS_I4)
	DISP_FUNCTION(CWaiteGLCtrl, "DrawBuffer", DrawBuffer, VT_EMPTY, VTS_I4)
	DISP_FUNCTION(CWaiteGLCtrl, "DepthMask", DepthMask, VT_EMPTY, VTS_BOOL)
	DISP_FUNCTION(CWaiteGLCtrl, "GetClipPlane", GetClipPlane, VT_EMPTY, VTS_I4 VTS_PR8 VTS_PR8 VTS_PR8 VTS_PR8)
	DISP_FUNCTION(CWaiteGLCtrl, "gluNewNurbsRenderer", gluNewNurbsRenderer, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWaiteGLCtrl, "gluDeleteNurbsRenderer", gluDeleteNurbsRenderer, VT_EMPTY, VTS_I4)
	DISP_FUNCTION(CWaiteGLCtrl, "gluBeginSurface", gluBeginSurface, VT_EMPTY, VTS_I4)
	DISP_FUNCTION(CWaiteGLCtrl, "gluEndCurve", gluEndCurve, VT_EMPTY, VTS_I4)
	DISP_FUNCTION(CWaiteGLCtrl, "gluBeginTrim", gluBeginTrim, VT_EMPTY, VTS_I4)
	DISP_FUNCTION(CWaiteGLCtrl, "gluBeginCurve", gluBeginCurve, VT_EMPTY, VTS_I4)
	DISP_FUNCTION(CWaiteGLCtrl, "gluEndSurface", gluEndSurface, VT_EMPTY, VTS_I4)
	DISP_FUNCTION(CWaiteGLCtrl, "gluEndTrim", gluEndTrim, VT_EMPTY, VTS_I4)
	DISP_FUNCTION(CWaiteGLCtrl, "gluPwlCurve", gluPwlCurve, VT_EMPTY, VTS_I4 VTS_I4 VTS_PR4 VTS_I4 VTS_I4)
	DISP_FUNCTION(CWaiteGLCtrl, "gluNurbsCurve", gluNurbsCurve, VT_EMPTY, VTS_I4 VTS_I4 VTS_PR4 VTS_I4 VTS_PR4 VTS_I4 VTS_I4)
	DISP_FUNCTION(CWaiteGLCtrl, "gluNurbsSurface", gluNurbsSurface, VT_EMPTY, VTS_I4 VTS_I4 VTS_PR4 VTS_I4 VTS_PR4 VTS_I4 VTS_I4 VTS_PR4 VTS_I4 VTS_I4 VTS_I4)
	DISP_FUNCTION(CWaiteGLCtrl, "gluNurbsProperty", gluNurbsProperty, VT_EMPTY, VTS_I4 VTS_I4 VTS_R4)
	DISP_FUNCTION(CWaiteGLCtrl, "gluGetNurbsProperty", gluGetNurbsProperty, VT_EMPTY, VTS_I4 VTS_I4 VTS_PR4)
	DISP_FUNCTION(CWaiteGLCtrl, "GetMap", GetMap, VT_EMPTY, VTS_I4 VTS_I4 VTS_PR4)
	DISP_FUNCTION(CWaiteGLCtrl, "EvalCoord1", EvalCoord1, VT_EMPTY, VTS_R4)
	DISP_FUNCTION(CWaiteGLCtrl, "EvalCoord2", EvalCoord2, VT_EMPTY, VTS_R4 VTS_R4)
	DISP_FUNCTION(CWaiteGLCtrl, "EvalMesh1", EvalMesh1, VT_EMPTY, VTS_I4 VTS_I4 VTS_I4)
	DISP_FUNCTION(CWaiteGLCtrl, "EvalMesh2", EvalMesh2, VT_EMPTY, VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_I4)
	DISP_FUNCTION(CWaiteGLCtrl, "EvalPoint1", EvalPoint1, VT_EMPTY, VTS_I4)
	DISP_FUNCTION(CWaiteGLCtrl, "EvalPoint2", EvalPoint2, VT_EMPTY, VTS_I4 VTS_I4)
	DISP_FUNCTION(CWaiteGLCtrl, "Map1", Map1, VT_EMPTY, VTS_I4 VTS_R4 VTS_R4 VTS_I4 VTS_I4 VTS_PR4)
	DISP_FUNCTION(CWaiteGLCtrl, "Map2", Map2, VT_EMPTY, VTS_I4 VTS_R4 VTS_R4 VTS_I4 VTS_I4 VTS_R4 VTS_R4 VTS_I4 VTS_I4 VTS_PR4)
	DISP_FUNCTION(CWaiteGLCtrl, "MapGrid1", MapGrid1, VT_EMPTY, VTS_I4 VTS_R4 VTS_R4)
	DISP_FUNCTION(CWaiteGLCtrl, "MapGrid2", MapGrid2, VT_EMPTY, VTS_I4 VTS_R4 VTS_R4 VTS_I4 VTS_R4 VTS_R4)
	DISP_FUNCTION(CWaiteGLCtrl, "GetTexEnvfv", GetTexEnvfv, VT_EMPTY, VTS_I4 VTS_I4 VTS_PR4)
	DISP_FUNCTION(CWaiteGLCtrl, "GetTexGenfv", GetTexGenfv, VT_EMPTY, VTS_I4 VTS_I4 VTS_PR4)
	DISP_FUNCTION(CWaiteGLCtrl, "GetTexLevelParameterfv", GetTexLevelParameterfv, VT_EMPTY, VTS_I4 VTS_I4 VTS_I4 VTS_PR4)
	DISP_FUNCTION(CWaiteGLCtrl, "GetTexParameterfv", GetTexParameterfv, VT_EMPTY, VTS_I4 VTS_I4 VTS_PR4)
	DISP_FUNCTION(CWaiteGLCtrl, "TexCoord1f", TexCoord1f, VT_EMPTY, VTS_R4)
	DISP_FUNCTION(CWaiteGLCtrl, "TexCoord2f", TexCoord2f, VT_EMPTY, VTS_R4 VTS_R4)
	DISP_FUNCTION(CWaiteGLCtrl, "TexCoord3f", TexCoord3f, VT_EMPTY, VTS_R4 VTS_R4 VTS_R4)
	DISP_FUNCTION(CWaiteGLCtrl, "TexCoord4f", TexCoord4f, VT_EMPTY, VTS_R4 VTS_R4 VTS_R4 VTS_R4)
	DISP_FUNCTION(CWaiteGLCtrl, "TexEnvf", TexEnvf, VT_EMPTY, VTS_I4 VTS_I4 VTS_R4)
	DISP_FUNCTION(CWaiteGLCtrl, "TexEnvfv", TexEnvfv, VT_EMPTY, VTS_I4 VTS_I4 VTS_PR4)
	DISP_FUNCTION(CWaiteGLCtrl, "TexGenf", TexGenf, VT_EMPTY, VTS_I4 VTS_I4 VTS_R4)
	DISP_FUNCTION(CWaiteGLCtrl, "TexGenfv", TexGenfv, VT_EMPTY, VTS_I4 VTS_I4 VTS_PR4)
	DISP_FUNCTION(CWaiteGLCtrl, "TexParameterf", TexParameterf, VT_EMPTY, VTS_I4 VTS_I4 VTS_R4)
	DISP_FUNCTION(CWaiteGLCtrl, "TexParameterfv", TexParameterfv, VT_EMPTY, VTS_I4 VTS_I4 VTS_PR4)
	DISP_FUNCTION(CWaiteGLCtrl, "TexImage1D", TexImage1D, VT_EMPTY, VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_PVARIANT)
	DISP_FUNCTION(CWaiteGLCtrl, "TexImage2D", TexImage2D, VT_EMPTY, VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_PVARIANT)
	DISP_FUNCTION(CWaiteGLCtrl, "PassThrough", PassThrough, VT_EMPTY, VTS_R4)
	//}}AFX_DISPATCH_MAP
	DISP_FUNCTION_ID(CWaiteGLCtrl, "AboutBox", DISPID_ABOUTBOX, AboutBox, VT_EMPTY, VTS_NONE)
END_DISPATCH_MAP()


/////////////////////////////////////////////////////////////////////////////
// Event map

BEGIN_EVENT_MAP(CWaiteGLCtrl, COleControl)
	//{{AFX_EVENT_MAP(CWaiteGLCtrl)
	EVENT_CUSTOM("Render", FireRender, VTS_NONE)
	EVENT_CUSTOM("SetupRC", FireSetupRC, VTS_NONE)
	//}}AFX_EVENT_MAP
END_EVENT_MAP()


/////////////////////////////////////////////////////////////////////////////
// Property pages

// TODO: Add more property pages as needed.  Remember to increase the count!
BEGIN_PROPPAGEIDS(CWaiteGLCtrl, 1)
	PROPPAGEID(CWaiteGLPropPage::guid)
END_PROPPAGEIDS(CWaiteGLCtrl)


/////////////////////////////////////////////////////////////////////////////
// Initialize class factory and guid

IMPLEMENT_OLECREATE_EX(CWaiteGLCtrl, "WAITEGL.WaiteGLCtrl.1",
	0x90e71ca3, 0x26f1, 0x11cf, 0xaa, 0xb1, 0x52, 0x41, 0x53, 0x48, 0, 0)


/////////////////////////////////////////////////////////////////////////////
// Type library ID and version

IMPLEMENT_OLETYPELIB(CWaiteGLCtrl, _tlid, _wVerMajor, _wVerMinor)


/////////////////////////////////////////////////////////////////////////////
// Interface IDs

const IID BASED_CODE IID_DWaiteGL =
		{ 0x90e71ca1, 0x26f1, 0x11cf, { 0xaa, 0xb1, 0x52, 0x41, 0x53, 0x48, 0, 0 } };
const IID BASED_CODE IID_DWaiteGLEvents =
		{ 0x90e71ca2, 0x26f1, 0x11cf, { 0xaa, 0xb1, 0x52, 0x41, 0x53, 0x48, 0, 0 } };


/////////////////////////////////////////////////////////////////////////////
// Control type information

static const DWORD BASED_CODE _dwWaiteGLOleMisc =
	OLEMISC_ACTIVATEWHENVISIBLE |
	OLEMISC_SETCLIENTSITEFIRST |
	OLEMISC_INSIDEOUT |
	OLEMISC_CANTLINKINSIDE |
	OLEMISC_RECOMPOSEONRESIZE;

IMPLEMENT_OLECTLTYPE(CWaiteGLCtrl, IDS_WAITEGL, _dwWaiteGLOleMisc)


/////////////////////////////////////////////////////////////////////////////
// CWaiteGLCtrl::CWaiteGLCtrlFactory::UpdateRegistry -
// Adds or removes system registry entries for CWaiteGLCtrl

BOOL CWaiteGLCtrl::CWaiteGLCtrlFactory::UpdateRegistry(BOOL bRegister)
	{
	if (bRegister)
		return AfxOleRegisterControlClass(
			AfxGetInstanceHandle(),
			m_clsid,
			m_lpszProgID,
			IDS_WAITEGL,
			IDB_WAITEGL,
			FALSE,                      //  Not insertable
			_dwWaiteGLOleMisc,
			_tlid,
			_wVerMajor,
			_wVerMinor);
	else
		return AfxOleUnregisterClass(m_clsid, m_lpszProgID);
	}


/////////////////////////////////////////////////////////////////////////////
// CWaiteGLCtrl::CWaiteGLCtrl - Constructor

CWaiteGLCtrl::CWaiteGLCtrl()
	{
	InitializeIIDs(&IID_DWaiteGL, &IID_DWaiteGLEvents);

	m_hRC		= NULL;	// OpenGL rendering context
	m_hDC		= NULL;	// Device context for this controls window
	m_bSetupRC	= NULL;	// Flag setup has not occured
	}


/////////////////////////////////////////////////////////////////////////////
// CWaiteGLCtrl::~CWaiteGLCtrl - Destructor

CWaiteGLCtrl::~CWaiteGLCtrl()
	{
	// TODO: Cleanup your control's instance data here.
	}


/////////////////////////////////////////////////////////////////////////////
// CWaiteGLCtrl::OnDraw - Drawing function

void CWaiteGLCtrl::OnDraw(
			CDC* pdc, const CRect& rcBounds, const CRect& rcInvalid)
	{
	COleControl::OnDraw(pdc, rcBounds, rcInvalid);

	// Only fire the SetupRC event once.
	if(!m_bSetupRC)
		{
		m_bSetupRC = TRUE;

		FireSetupRC();
		}

	// Fire the render event
	FireRender();
	}


/////////////////////////////////////////////////////////////////////////////
// CWaiteGLCtrl::DoPropExchange - Persistence support

void CWaiteGLCtrl::DoPropExchange(CPropExchange* pPX)
	{
	ExchangeVersion(pPX, MAKELONG(_wVerMinor, _wVerMajor));
	COleControl::DoPropExchange(pPX);

	// TODO: Call PX_ functions for each persistent custom property.
	}



/////////////////////////////////////////////////////////////////////////////
// CWaiteGLCtrl::OnResetState - Reset control to default state

void CWaiteGLCtrl::OnResetState()
	{
	COleControl::OnResetState();  // Resets defaults found in DoPropExchange

	// TODO: Reset any other control state here.
	}


/////////////////////////////////////////////////////////////////////////////
// CWaiteGLCtrl::AboutBox - Display an "About" box to the user

void CWaiteGLCtrl::AboutBox()
	{
	CDialog dlgAbout(IDD_ABOUTBOX_WAITEGL);
	dlgAbout.DoModal();
	}


/////////////////////////////////////////////////////////////////////////////
// CWaiteGLCtrl message handlers




// Create the control with the pixel format and rendering context
int CWaiteGLCtrl::OnCreate(LPCREATESTRUCT lpCreateStruct) 
	{
	static PIXELFORMATDESCRIPTOR pfd = {
		sizeof(PIXELFORMATDESCRIPTOR),	// Size of this structure
		1,								// Version of this structure	
		PFD_DRAW_TO_WINDOW |			// Draw to Window (not to bitmap)
		PFD_SUPPORT_OPENGL |			// Support OpenGL calls in window
		PFD_DOUBLEBUFFER,				// Double buffered mode
		PFD_TYPE_RGBA,					// RGBA Color mode
		24,								// Want 24bit color 
		0,0,0,0,0,0,					// Not used to select mode
		0,0,							// Not used to select mode
		0,0,0,0,0,						// Not used to select mode
		32,								// Size of depth buffer
		0,								// Not used to select mode
		0,								// Not used to select mode
		PFD_MAIN_PLANE,					// Draw in main plane
		0,								// Not used to select mode
		0,0,0 };						// Not used to select mode

	// Enable Pixel format with required styles, also get and save
	// the device context
	lpCreateStruct->style |= (WS_CLIPCHILDREN | WS_CLIPSIBLINGS | CS_OWNDC);

	if (COleControl::OnCreate(lpCreateStruct) == -1)
		return -1;

	// Get and save the device context
	m_hDC = ::GetDC(this->m_hWnd);

	// Choose a pixel format that best matches that described in pfd
	int nPixelFormat = ChoosePixelFormat(m_hDC, &pfd);
	SetPixelFormat(m_hDC, nPixelFormat, &pfd);

	InitializePalette();

	m_hRC = wglCreateContext(m_hDC);

	// Make this objects rendering context not current
	MakeNotCurrent();

	return 0;
	}


// Initializes the CPalette object
void CWaiteGLCtrl::InitializePalette(void)
	{
	PIXELFORMATDESCRIPTOR pfd;	// Pixel Format Descriptor
	LOGPALETTE *pPal;			// Pointer to memory for logical palette
	int nPixelFormat;			// Pixel format index
	int nColors;				// Number of entries in palette
	int i;						// Counting variable
	BYTE RedRange,GreenRange,BlueRange;
								// Range for each color entry (7,7,and 3)

	// Get the pixel format index and retrieve the pixel format description
	nPixelFormat = GetPixelFormat(m_hDC);
	DescribePixelFormat(m_hDC, nPixelFormat, sizeof(PIXELFORMATDESCRIPTOR), &pfd);

	// Does this pixel format require a palette?  If not, do not create a
	// palette and just return NULL
	if(!(pfd.dwFlags & PFD_NEED_PALETTE))
		return;

	// Number of entries in palette.  8 bits yeilds 256 entries
	nColors = 1 << pfd.cColorBits;	

	// Allocate space for a logical palette structure plus all the palette entries
	pPal = (LOGPALETTE*)malloc(sizeof(LOGPALETTE) +nColors*sizeof(PALETTEENTRY));

	// Fill in palette header 
	pPal->palVersion = 0x300;		// Windows 3.0
	pPal->palNumEntries = nColors; // table size

	// Build mask of all 1's.  This creates a number represented by having
	// the low order x bits set, where x = pfd.cRedBits, pfd.cGreenBits, and
	// pfd.cBlueBits.  
	RedRange = (1 << pfd.cRedBits) -1;
	GreenRange = (1 << pfd.cGreenBits) - 1;
	BlueRange = (1 << pfd.cBlueBits) -1;

	// Loop through all the palette entries
	for(i = 0; i < nColors; i++)
		{
		// Fill in the 8-bit equivalents for each component
		pPal->palPalEntry[i].peRed = (i >> pfd.cRedShift) & RedRange;
		pPal->palPalEntry[i].peRed = (unsigned char)(
			(double) pPal->palPalEntry[i].peRed * 255.0 / RedRange);

		pPal->palPalEntry[i].peGreen = (i >> pfd.cGreenShift) & GreenRange;
		pPal->palPalEntry[i].peGreen = (unsigned char)(
			(double)pPal->palPalEntry[i].peGreen * 255.0 / GreenRange);

		pPal->palPalEntry[i].peBlue = (i >> pfd.cBlueShift) & BlueRange;
		pPal->palPalEntry[i].peBlue = (unsigned char)(
			(double)pPal->palPalEntry[i].peBlue * 255.0 / BlueRange);

		pPal->palPalEntry[i].peFlags = (unsigned char) NULL;
		}
		
	// Create the palette
	m_GLPalette.CreatePalette(pPal);

	// Go ahead and select and realize the palette for this device context
	SelectPalette(m_hDC,(HPALETTE)m_GLPalette,FALSE);
	RealizePalette(m_hDC);

	// Free the memory used for the logical palette structure
	free(pPal);
	}


BOOL CWaiteGLCtrl::OnQueryNewPalette() 
	{
	// If the palette was created.
	if((HPALETTE)m_GLPalette)
		{
		int nRet;

		// Selects the palette into the current device context
		SelectPalette(m_hDC, (HPALETTE)m_GLPalette, FALSE);

		// Map entries from the currently selected palette to
		// the system palette.  The return value is the number 
		// of palette entries modified.
		nRet = RealizePalette(m_hDC);

		// Repaint, forces remap of palette in current window
		InvalidateRect(NULL,FALSE);

		return nRet;
		}
	return COleControl::OnQueryNewPalette();
	}


void CWaiteGLCtrl::OnPaletteChanged(CWnd* pFocusWnd) 
	{
	if(((HPALETTE)m_GLPalette != NULL) && (pFocusWnd != this))
		{
		// Select the palette into the device context
		SelectPalette(m_hDC,(HPALETTE)m_GLPalette,FALSE);

		// Map entries to system palette
		RealizePalette(m_hDC);
				
		// Remap the current colors to the newly realized palette
		UpdateColors(m_hDC);
		return;
		}

	COleControl::OnPaletteChanged(pFocusWnd);
	}


void CWaiteGLCtrl::OnDestroy() 
	{
	COleControl::OnDestroy();

	// Clean up the rendering and device contexts
	if(m_hRC)
		{
		wglMakeCurrent(m_hDC,NULL);
		wglDeleteContext(m_hRC);
		}
	}


//////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////
// METHODS
//////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////

// Makes the rendering context for this control current
BOOL CWaiteGLCtrl::MakeCurrent() 
	{
	return wglMakeCurrent(m_hDC,m_hRC);
	}


// Makes the rendering context for this control not current
BOOL CWaiteGLCtrl::MakeNotCurrent() 
	{
	return wglMakeCurrent(m_hDC,NULL);
	}

// This function needs to blit the bitmap to the window
BOOL CWaiteGLCtrl::SwapBuffers() 
	{
	// TODO: copy canvas to presentation, then invalidate
	// to force an OnDraw
	::SwapBuffers(m_hDC);

	return TRUE;
	}

// Return the rendering context
long CWaiteGLCtrl::wglGetRC() 
	{
	return (long)m_hRC;
	}

// Return the device context
long CWaiteGLCtrl::wglGetDC() 
	{
	return (long)m_hDC;
	}

// wglUseFontBitmaps
BOOL CWaiteGLCtrl::wglUseFontBitmaps(long hdc, long first, long count, long listbase) 
	{
	::wglUseFontBitmaps((HDC)hdc, first, count, listbase);
	return TRUE;
	}

