VERSION 4.00
Begin VB.Form Form1 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Rings"
   ClientHeight    =   6165
   ClientLeft      =   1860
   ClientTop       =   2670
   ClientWidth     =   9060
   Height          =   6570
   Left            =   1800
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   6165
   ScaleWidth      =   9060
   Top             =   2325
   Width           =   9180
   Begin VB.CommandButton Command1 
      Caption         =   "&Close"
      Height          =   375
      Left            =   7800
      TabIndex        =   0
      Top             =   5640
      Width           =   855
   End
   Begin WAITEGLLib.WaiteGL glAPI 
      Height          =   5295
      Left            =   240
      TabIndex        =   1
      Top             =   240
      Width           =   8535
      _Version        =   65536
      _ExtentX        =   15055
      _ExtentY        =   9340
      _StockProps     =   0
   End
End
Attribute VB_Name = "Form1"
Attribute VB_Creatable = False
Attribute VB_Exposed = False
Dim floorList, poleList, ringListBase As Integer

Public Sub BuildLists()
    Dim floorsize, x, z, division, listBase, poleObj
    
    Rem Get First display list
    listBase = glAPI.GenLists(10)
    
    floorList = listBase
    poleList = listBase + 1
    ringListBase = listBase + 2
    
    Rem Create a Pole
    glAPI.NewList poleList, glAPI.glCompile
    glAPI.Color 255, 0, 0, 255
    poleObj = glAPI.gluNewQuadric

      glAPI.gluQuadricNormals poleObj, glAPI.gluFlat
      glAPI.gluQuadricOrientation poleObj, glAPI.gluOutside
      glAPI.gluQuadricDrawStyle poleObj, glAPI.gluFill
      glAPI.gluCylinder poleObj, 7, 7, 60, 25, 25

      glAPI.gluDeleteQuadric poleObj
   glAPI.EndList
    
    
    
    Rem Create floor
    glAPI.NewList floorList, glAPI.glCompile()
       
    floorsize = 200
    division = 10
        
    Rem White floor
    glAPI.Color 255, 255, 255, 255
        
    Rem Tile to improve spot effects
    For x = -floorsize To floorsize Step division
        For z = -floorsize To floorsize Step division
            glAPI.start (glAPI.glQuads())
            glAPI.Normal 0, 1, 0
            glAPI.Vertex3 x, 0, z
            glAPI.Vertex3 x, 0, z + division
            glAPI.Vertex3 x + division, 0, z + division
            glAPI.Vertex3 x + division, 0, z
            glAPI.Stop
        Next z
    Next x
    glAPI.EndList
    
    
   Rem Build the Rings
   Rem Small top ring (Red)
   glAPI.NewList ringListBase, glAPI.glCompile()
   glAPI.Color 255, 0, 0, 255
   glAPI.auxSolidTorus 10, 25
   glAPI.EndList
    
   Rem (Blue)
   glAPI.NewList ringListBase + 1, glAPI.glCompile()
   glAPI.Color 0, 0, 255, 255
   glAPI.auxSolidTorus 9, 22
   glAPI.EndList
    
   Rem (Green)
   glAPI.NewList ringListBase + 2, glAPI.glCompile()
   glAPI.Color 0, 255, 0, 255
   glAPI.auxSolidTorus 8, 19
   glAPI.EndList

   Rem (Yellow)
   glAPI.NewList ringListBase + 3, glAPI.glCompile()
   glAPI.Color 255, 255, 0, 255
   glAPI.auxSolidTorus 7, 16
   glAPI.EndList

   Rem (Purple)
   glAPI.NewList ringListBase + 4, glAPI.glCompile()
   glAPI.Color 255, 0, 255, 255
   glAPI.auxSolidTorus 6, 13
   glAPI.EndList


   Rem (Light Blue)
   glAPI.NewList ringListBase + 5, glAPI.glCompile()
   glAPI.Color 0, 255, 255, 255
   glAPI.auxSolidTorus 5, 9
   glAPI.EndList

   glAPI.Flush
   
    
End Sub

Private Sub Command1_Click()
    End
End Sub


Private Sub Form_Load()
    glAPI.MakeCurrent
    
End Sub

Private Sub Form_Terminate()
    glAPI.MakeNotCurrent
    
End Sub


Private Sub glAPI_Render()

    glAPI.Clear (glAPI.glColorBufferBit())
    glAPI.Clear (glAPI.glDepthBufferBit())
    
    glAPI.Color 255, 0, 0, 255
    
    glAPI.PushMatrix
    glAPI.Rotate 90, 1, 0, 0

    glAPI.CallList poleList
     
    glAPI.Translate 0, 0, 40
    glAPI.CallList ringListBase

    glAPI.Translate 0, 0, -18
    glAPI.CallList (ringListBase + 1)

    glAPI.Translate 0, 0, -17
    glAPI.CallList (ringListBase + 2)

    glAPI.Translate 0, 0, -15
    glAPI.CallList (ringListBase + 3)

    glAPI.Translate 0, 0, -13
    glAPI.CallList (ringListBase + 4)

    glAPI.Translate 0, 0, -11
    glAPI.CallList (ringListBase + 5)
    
    glAPI.PopMatrix
    
    Rem Draw the floor
    glAPI.PushMatrix
    glAPI.Translate 0, -75, 0
    
    Rem Call display list to draw the floor
    glAPI.CallList floorList
 
 
    glAPI.PopMatrix
        
    glAPI.Flush
    glAPI.SwapBuffers
    
End Sub


Private Sub glAPI_SetupRC()
     
    glAPI.Enable (glAPI.glDepthTest())
    glAPI.Enable (glAPI.glColorMaterial())
    glAPI.Enable (glAPI.glCullFace())
    glAPI.FrontFace (glAPI.glCcw())
    
    glAPI.MatrixMode (glAPI.glProjection())
     
    glAPI.LoadIdentity
         
    Rem Setup perspective for viewing
    glAPI.gluPerspective 45#, Width / Height, 100, 500
    glAPI.MatrixMode (glAPI.glModelview())
     
    Rem Viewing transformation
    glAPI.LoadIdentity
    glAPI.Translate 0#, 0#, -300#
  
    Rem Turn on the lights
    glAPI.Enable (glAPI.glLighting())
    
    Rem left hand light
    glAPI.LightModelv glAPI.glLightModelAmbient, 0.5, 0.5, 0.5, 0.5
    glAPI.Lightf glAPI.glLight0(), glAPI.glDiffuse(), 0.6, 0.6, 0.6, 0.6
    glAPI.Lightf glAPI.glLight0(), glAPI.glSpecular(), 1#, 1#, 1#, 1#
    glAPI.Lightf glAPI.glLight0(), glAPI.glPosition(), -200#, 200#, 100#, 1#
    glAPI.Light glAPI.glLight0(), glAPI.glSpotCutoff(), 90#
    glAPI.Light glAPI.glLight0(), glAPI.glSpotExponent(), 60#
    glAPI.Lightf glAPI.glLight0(), glAPI.glSpotDirection(), 0.3, -1#, -0.3, 1#

    Rem center light
    glAPI.LightModelv glAPI.glLightModelAmbient, 0.5, 0.5, 0.5, 0.5
    glAPI.Lightf glAPI.glLight1(), glAPI.glDiffuse(), 0.6, 0.6, 0.6, 0.6
    glAPI.Lightf glAPI.glLight1(), glAPI.glSpecular(), 1#, 1#, 1#, 1#
    glAPI.Lightf glAPI.glLight1(), glAPI.glPosition(), -75#, 200#, 150#, 1#
    glAPI.Light glAPI.glLight1(), glAPI.glSpotCutoff(), 90#
    glAPI.Light glAPI.glLight1(), glAPI.glSpotExponent(), 60#
    glAPI.Lightf glAPI.glLight1(), glAPI.glSpotDirection(), 0.3, -1#, -0.5, 1#

    Rem right hand light
    glAPI.LightModelv glAPI.glLightModelAmbient, 0.5, 0.5, 0.5, 0.5
    glAPI.Lightf glAPI.glLight2(), glAPI.glDiffuse(), 0.6, 0.6, 0.6, 0.6
    glAPI.Lightf glAPI.glLight2(), glAPI.glSpecular(), 1#, 1#, 1#, 1#
    glAPI.Lightf glAPI.glLight2(), glAPI.glPosition(), 50#, 200#, 100#, 1#
    glAPI.Light glAPI.glLight2(), glAPI.glSpotCutoff(), 90#
    glAPI.Light glAPI.glLight2(), glAPI.glSpotExponent(), 60#
    glAPI.Lightf glAPI.glLight2(), glAPI.glSpotDirection(), 0.3, -1#, -0.3, 1#


    glAPI.Enable (glAPI.glLight0())
    glAPI.Enable (glAPI.glLight1())
    glAPI.Enable (glAPI.glLight2())
    
    glAPI.Enable (glAPI.glNormalize())
    glAPI.Enable (glAPI.glAutoNormal())
    
    glAPI.ColorMaterial glAPI.glFront(), glAPI.glAmbientAndDiffuse()
    glAPI.Materialv glAPI.glFront(), glAPI.glSpecular(), 1#, 1#, 1#, 1#
    glAPI.Material glAPI.glFront(), glAPI.glShininess(), 10#
       
         
    glAPI.ClearColor 0, 0, 0, 255
    
    Rem Flush the commands
    glAPI.Flush
   
    Rem Construct the display lists that we will be using
    BuildLists
        
   
   
End Sub


