// slstboltView.h : interface of the CSlstboltView class
//
/////////////////////////////////////////////////////////////////////////////

class CSlstboltView : public CView
{
protected: // create from serialization only
	CSlstboltView();
	DECLARE_DYNCREATE(CSlstboltView)

// Attributes
public:
	CSlstboltDoc* GetDocument();

// Operations
public:

	HGLRC m_hRC;	// Rendering Context
	HDC m_hDC;		// Device Context

	CPalette m_GLPalette;	// Logical Palette

protected:
	void InitializePalette(void);

public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CSlstboltView)
	public:
	virtual void OnDraw(CDC* pDC);  // overridden to draw this view
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	protected:
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CSlstboltView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	//{{AFX_MSG(CSlstboltView)
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnDestroy();
	afx_msg BOOL OnEraseBkgnd(CDC* pDC);
	afx_msg void OnPaletteChanged(CWnd* pFocusWnd);
	afx_msg BOOL OnQueryNewPalette();
	afx_msg void OnTimer(UINT nIDEvent);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

#ifndef _DEBUG  // debug version in slstboltView.cpp
inline CSlstboltDoc* CSlstboltView::GetDocument()
   { return (CSlstboltDoc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////
