// NurbsView.h : interface of the CNurbsView class
//
/////////////////////////////////////////////////////////////////////////////

class CNurbsView : public CView
{
protected: // create from serialization only
	CNurbsView();
	DECLARE_DYNCREATE(CNurbsView)

// Attributes
public:
	CNurbsDoc* GetDocument();

// Operations
public:

	HGLRC m_hRC;	// Rendering Context
	HDC m_hDC;		// Device Context

	CPalette m_GLPalette;	// Logical Palette

protected:
	void InitializePalette(void);

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CNurbsView)
	public:
	virtual void OnDraw(CDC* pDC);  // overridden to draw this view
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	protected:
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CNurbsView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	//{{AFX_MSG(CNurbsView)
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnDestroy();
	afx_msg BOOL OnEraseBkgnd(CDC* pDC);
	afx_msg BOOL OnQueryNewPalette();
	afx_msg void OnPaletteChanged(CWnd* pFocusWnd);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

#ifndef _DEBUG  // debug version in NurbsView.cpp
inline CNurbsDoc* CNurbsView::GetDocument()
   { return (CNurbsDoc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////
