// RGBTrnglView.h : interface of the CRGBTrnglView class
//
/////////////////////////////////////////////////////////////////////////////

class CRGBTrnglView : public CView
{
protected: // create from serialization only
	CRGBTrnglView();
	DECLARE_DYNCREATE(CRGBTrnglView)

// Attributes
public:
	CRGBTrnglDoc* GetDocument();

// Attributes
public:
	HGLRC m_hRC;	// Rendering Context
	HDC m_hDC;		// Device Context

	CPalette m_GLPalette;	// Logical Palette


// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CRGBTrnglView)
	public:
	virtual void OnDraw(CDC* pDC);  // overridden to draw this view
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	protected:
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CRGBTrnglView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:
	void InitializePalette(void);

// Generated message map functions
protected:
	//{{AFX_MSG(CRGBTrnglView)
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnDestroy();
	afx_msg BOOL OnEraseBkgnd(CDC* pDC);
	afx_msg BOOL OnQueryNewPalette();
	afx_msg void OnPaletteChanged(CWnd* pFocusWnd);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

#ifndef _DEBUG  // debug version in RGBTrnglView.cpp
inline CRGBTrnglDoc* CRGBTrnglView::GetDocument()
   { return (CRGBTrnglDoc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////
