//----------------------------------------------------------------------------
//  Project Slstbolt
//  Waite Group Press
//  Copyright  1996. All Rights Reserved.
//
//  SUBSYSTEM:    Slstbolt Application
//  FILE:         slstblad.h
//  AUTHOR:       Richard S. Wright Jr.
//
//  OVERVIEW
//  ~~~~~~~~
//  Class definition for TSlstboltAboutDlg (TDialog).
//
//----------------------------------------------------------------------------
#if !defined(slstblad_h)              // Sentry, use file only if it's not already included.
#define slstblad_h

#include <owl/static.h>

#include "slstblta.rh"                  // Definition of all resources.


//{{TDialog = TSlstboltAboutDlg}}
class TSlstboltAboutDlg : public TDialog {
  public:
    TSlstboltAboutDlg(TWindow* parent, TResId resId = IDD_ABOUT, TModule* module = 0);
    virtual ~TSlstboltAboutDlg();

//{{TSlstboltAboutDlgVIRTUAL_BEGIN}}
  public:
    void SetupWindow();
//{{TSlstboltAboutDlgVIRTUAL_END}}
};    //{{TSlstboltAboutDlg}}


// Reading the VERSIONINFO resource.
//
class TProjectRCVersion {
  public:
    TProjectRCVersion(TModule* module);
    virtual ~TProjectRCVersion();

    bool GetProductName(LPSTR& prodName);
    bool GetProductVersion(LPSTR& prodVersion);
    bool GetCopyright(LPSTR& copyright);
    bool GetDebug(LPSTR& debug);

  protected:
    uint8 far*  TransBlock;
    void far*   FVData;

  private:
    // Don't allow this object to be copied.
    //
    TProjectRCVersion(const TProjectRCVersion&);
    TProjectRCVersion& operator = (const TProjectRCVersion&);
};


#endif  // slstblad_h sentry.
