//----------------------------------------------------------------------------
//  Project Triangle
//  Waite Group Press
//  Copyright  1996. All Rights Reserved.
//
//  SUBSYSTEM:    Triangle Application
//  FILE:         trnglabd.h
//  AUTHOR:       Richard S. Wright Jr.
//
//  OVERVIEW
//  ~~~~~~~~
//  Class definition for TTriangleAboutDlg (TDialog).
//
//----------------------------------------------------------------------------
#if !defined(trnglabd_h)              // Sentry, use file only if it's not already included.
#define trnglabd_h

#include <owl/static.h>

#include "trnglapp.rh"                  // Definition of all resources.


//{{TDialog = TTriangleAboutDlg}}
class TTriangleAboutDlg : public TDialog {
  public:
    TTriangleAboutDlg(TWindow* parent, TResId resId = IDD_ABOUT, TModule* module = 0);
    virtual ~TTriangleAboutDlg();

//{{TTriangleAboutDlgVIRTUAL_BEGIN}}
  public:
    void SetupWindow();
//{{TTriangleAboutDlgVIRTUAL_END}}
};    //{{TTriangleAboutDlg}}


// Reading the VERSIONINFO resource.
//
class TProjectRCVersion {
  public:
    TProjectRCVersion(TModule* module);
    virtual ~TProjectRCVersion();

    bool GetProductName(LPSTR& prodName);
    bool GetProductVersion(LPSTR& prodVersion);
    bool GetCopyright(LPSTR& copyright);
    bool GetDebug(LPSTR& debug);

  protected:
    uint8 far*  TransBlock;
    void far*   FVData;

  private:
    // Don't allow this object to be copied.
    //
    TProjectRCVersion(const TProjectRCVersion&);
    TProjectRCVersion& operator = (const TProjectRCVersion&);
};


#endif  // trnglabd_h sentry.
